<%
response.setHeader("Cache-Control","no-store"); //HTTP 1.1
response.setHeader("Pragma","no-cache"); //HTTP 1.0
response.setDateHeader ("Expires", 0); //prevents caching at the proxy server
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/admin/group/RoleEntitlements.java" --%><%-- /jsf:pagecode --%>
<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2006. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  -----------------------------------------------------------------------------%>
<%--
 -  $$RCSfile: roleEntitlements.jsp,v $$
 -  $$Revision: 1.44 $$  $$Date: 2007/08/05 18:33:57 $$
 --%>  
  
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>  

<html>
<head>
	<%@include file="/theme/metaHeader.jspf" %>
	<meta http-equiv="Pragma" content="no-cache">
	<%@include file="/theme/cssHideRightColumn.jspf"%>
	<link rel="csh" href="${applicationScope.cshPath}">
	<title>${bundle.adminTitle}</title>
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/categorize_tree.js"></script> 
	<script language="JavaScript" type="text/javascript" src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/role.js"></script>
    
</head>
<f:view>
	<body class="ram">
		<hx:scriptCollector id="scriptCollector1">
			<%@ include file="/theme/header.jspf" %>
			
			<div id="contentColumn">
			<div class="inside">
				<ram:form id="form1">
				<div class="primaryActionGroup_float_top">
					<hx:commandExButton
						type="submit" value="#{bundle.button_ok}"
						styleClass="commandExButton"
						id="topUpdateRole"
						action="#{pc_RoleEntitlements.updateRole}" />
					<hx:commandExButton 
						type="submit" value="#{bundle.button_cancel}"
						id="topCancelUpdate" styleClass="commandExButton"
						action="#{pc_RoleEntitlements.cancelUpdate}" />
				</div>
				<h1>
					
					<h:outputText id="pageTitle" value="#{pc_RoleEntitlements.group.name}" />
					<ram:infopop id="pageHelp" styleClass="pageHelp" image="/theme/images/icons/obj16/info_indicator.gif" 
						contextId="tsrc0001"/>
				</h1>
			
				<ram:contentTabs id="tabContentTabs" value="#{breadcrumbsManager.contentTabs}" activeLinks="#{breadcrumbsManager.activeLinks}" />
				
				
				<h2>${bundle.page_title_role_permissions}</h2>
				
				<h:outputText id="page_help" styleClass="sectionInstructions"
					value="#{bundle.help_page_role}" />
				
				<ram:messagesEx id="messages" globalOnly="true" />

				
				<hx:panelFormBox helpPosition="under" labelPosition="left"
					id="formBox1" styleClass="panelFormBox">
					<hx:formItem id="formItem2" styleClass="formItem" label="#{bundle.label_name}">
						<h:inputText id="inputName"	value="#{pc_RoleEntitlements.role.name}" styleClass="longField"/>
					</hx:formItem>
				<h:message id="formItem2Error" styleClass="message" for="inputName"/>
				<hx:formItem id="formItem3" styleClass="formItem" label="#{bundle.label_description}">
						<h:inputTextarea id="descriptionID" styleClass="longField" rows="5"
							value="#{pc_RoleEntitlements.role.description}"/>
						
				</hx:formItem>
				<h:message id="formItem3Error" styleClass="message" for="descriptionID"/>
				</hx:panelFormBox>

				<div class="primarySectionHeader">
					<h2><ram:infopop id="permissionsInfopop" styleClass="jazz-app-ua-TextHoverHelp" contextId="tsrc0010" text="#{bundle.section_role_permissions}" /></h2>
				</div>
				<h:outputText id="section_help1" styleClass="sectionInstructions"
					value="#{bundle.help_section_role_permissions}" />
					
			<hx:dataTableEx border="0"
				width="100%" rowClasses="oddRow, evenRow"
				styleClass="displayTable secondaryTable"
				columnClasses="selectColumn, noClass, noClass" id="rolesTable"
				var="varroleEntitlements"
				value="#{pc_RoleEntitlements.allEntitlements}"
				summary="#{bundle.alt_table_role_permissions}">

				<hx:columnEx id="selectrole">
					<f:facet name="header">
						<hx:outputSelecticons id="selecticons1" for="rolesTable"
							styleClass="selectIcons"
							srcInverse="#{pc_RoleEntitlements.nullImage}"
							srcAll="#{pc_RoleEntitlements.checkAllImage}"
							srcNone="#{pc_RoleEntitlements.checkNoneImage}" />
					</f:facet>
					<hx:inputRowSelect binding="#{pc_RoleEntitlements.usercheckbox}"
						value="#{varroleEntitlements.selected}" id="usercheckbox"
						rendered="#{!varroleEntitlements.disabled}"
						srcSelected="#{pc_RoleEntitlements.checkedBoxImage}"
						srcUnselected="#{pc_RoleEntitlements.uncheckedBoxImage}" />
					<hx:graphicImageEx
						id="disabledChkBoxImage"
						rendered="#{varroleEntitlements.disabled && varroleEntitlements.selected}"
						value="#{pc_RoleEntitlements.disabledCheckedBox}" />
					<hx:graphicImageEx
						id="disabledUnchkBox"
						rendered="#{varroleEntitlements.disabled && !varroleEntitlements.selected}"
						value="#{pc_RoleEntitlements.disabledUncheckedBox}" />
				</hx:columnEx>

				<hx:columnEx id="column1" style="vertical-align: top; width: 30%">
					<f:facet name="header">
						<h:outputText id="permissionColumHeather" value="#{bundle.column_permission}" />
					</f:facet>
					<h:graphicImage id="assignedImage" styleClass="graphicImage"
						value="#{pc_RoleEntitlements.entitlementImage}"
						style="margin-right: 3px" alt=""/>
					<h:outputText id="assignedRole"
						value="#{varroleEntitlements.label}" />
				</hx:columnEx>

				<hx:columnEx id="descriptionColumn" style="width:70%">
					<f:facet name="header">
						<h:outputText id="entDescHeather" value="#{bundle.column_description}" />
					</f:facet>
					<h:outputText id="entDescription" value="#{varroleEntitlements.description}" />
				</hx:columnEx>
			</hx:dataTableEx>

			<div class="primarySectionHeader">
				<h2><ram:infopop id="scopeInfopop" styleClass="jazz-app-ua-TextHoverHelp" contextId="tsrc0020" text="#{bundle.section_role_scope}" /></h2>
			</div>
			<h:outputText id="section_help2" styleClass="sectionInstructions"
				value="#{bundle.help_section_role_scope}" />
				
			<table class="formTable" cellspacing="3">
				<tbody>
					<tr>
						<td class="label" style="white-space: nowrap; padding: 6px 0"><h:outputText id="roleScopeApplies" value="#{bundle.label_role_scope_applies} " /></td>
						<td class="input">
							<h:selectOneRadio layout="lineDirection" id="andOrRadios" disabled="#{pc_RoleEntitlements.testEntriesCt <= 1}" 
							value="#{pc_RoleEntitlements.testsRoot.andOr}" binding="#{pc_RoleEntitlements.andOrRadios}">
								<f:selectItem id="selectAnd" itemValue="and" itemLabel="#{bundle.option_role_scope_all}" />
								<f:selectItem id="selectOr" itemValue="or" itemLabel="#{bundle.option_role_scope_atLeast}" />
							</h:selectOneRadio>
						</td>
					</tr>
				</tbody>
			</table>
			
			<hx:dataTableEx border="0"
				rowClasses="oddRow, evenRow" id="testsTable" styleClass="displayTable secondaryTable" columnClasses="selectColumn, noClass, noClass, noClass"
				value="#{pc_RoleEntitlements.testEntries}" var="vartestEntries"
				summary="#{bundle.alt_table_role_scope}">
				
				<hx:columnEx id="columnEx1" nowrap="true">
					<f:facet name="header">
						<hx:outputSelecticons id="selecticons2"  for="testsTable" styleClass="selectIcons"
							srcInverse="#{pc_RoleEntitlements.nullImage}"
							srcAll="#{pc_RoleEntitlements.checkAllImage}" 
							srcNone="#{pc_RoleEntitlements.checkNoneImage}" />
					</f:facet>					
					<hx:inputRowSelect value="#{vartestEntries.selected}" id="selectedTest"
						srcSelected="#{pc_RoleEntitlements.checkedBoxImage}"
						srcUnselected="#{pc_RoleEntitlements.uncheckedBoxImage}" />
				</hx:columnEx>
				<hx:columnEx id="testTypeCol" width="40%">
					<f:facet name="header"><h:outputText id="testTypeHead" value="#{bundle.column_type}" /></f:facet>
					<h:outputText id="testTypeVal" value="#{vartestEntries.testTypeDisplayName}"/>
				</hx:columnEx>
				<hx:columnEx id="notCol" width="20%" style="white-space: nowrap">
					<h:outputText id="notString" value="#{vartestEntries.notString}" />
				</hx:columnEx>
				<hx:columnEx id="valCol" width="40%">
					<f:facet name="header"><h:outputText id="valHead" value="#{bundle.column_value}" /></f:facet>
					<h:outputText id="valText" converter="ram.converter.AssetTestValueConverter"
						value="#{vartestEntries.selectedOption}" />
				</hx:columnEx>
			</hx:dataTableEx>
					<div style="padding-top:10px;padding-bottom:10px;">
					<h:selectOneMenu id="newRoleTestType" 
						value="#{pc_RoleEntitlements.newTest.testType}" 
						binding="#{pc_RoleEntitlements.newTestTypecomponent}" 
						styleClass="shortSelect" style="width:auto; margin-right: 3px"
						title="#{bundle.alt_role_test_constraint}" onchange="switchView(value)">
						<f:selectItems id="typesList" value="#{pc_RoleEntitlements.testTypes}" />
					</h:selectOneMenu>
					<h:selectOneMenu id="newNotString" value="#{pc_RoleEntitlements.newTest.notString}" 
						styleClass="shortSelect" style="width:auto; margin-right: 3px"
						title="#{bundle.alt_role_test_condition}">
						<f:selectItem id="newMust" itemValue="option_must_be" itemLabel="#{bundle.option_must_be}" />
						<f:selectItem id="newMustNot" itemValue="option_must_not_be" itemLabel="#{bundle.option_must_not_be}" />
					</h:selectOneMenu>
					<div id="submit-type" style="padding-top:10px;padding-bottom:10px;">
					<h2>${bundle.page_title_role_asset_type}</h2>
						<h:selectOneMenu id="testValue" converter="ram.converter.AssetTestValueConverter"
							value="#{pc_RoleEntitlements.newTest.selectedOption}" styleClass="shortSelect" style="width:auto; margin-right: 3px"
							title="#{bundle.alt_role_test_value}">
							<f:selectItems id="newOptions" value="#{pc_RoleEntitlements.newTest.typeOptions}" />
						</h:selectOneMenu>
					</div>
					</div>
				 	
				 <div id="submit-categories" style="display: none;">
				 <h2>${bundle.page_title_role_asset_category}</h2>
					<div style="margin-top: 10px">
						<h:outputText id="instructCategorize" value="#{bundle.help_submit_section_categories}" styleClass="sectionInstructions"/>
						<div id="categoryInputPanel" style="width: 45%; float: left;">
						<h:outputText id="availableCategoriesLabel" styleClass="label" value="#{bundle.label_available_categories}" />
						<div id="categoryInputContainer" class="categoryTreeContainer">	
						</div>
						</div>
						<div id="categoryOutputPanel" style="width: 45%; float: left;">
						<h:outputText id="appliedCategoriesLabel" styleClass="label" value="#{bundle.label_applied_categories}" />
						<div id="categoryOutputContainer" class="categoryTreeContainer">
						</div>
						</div>
						
						<div style="clear: both;"></div>
					</div><h:inputHidden id="selectedCategories" binding="#{pc_RoleEntitlements.assetCategorycomponent}"  /></div>
			<div style="padding-top:10px">
				<h:panelGroup id="testConstraintPanel">
					<hx:ajaxRefreshSubmit id="ajaxrefresh1" />
					<hx:commandExButton type="submit" value="#{bundle.button_removeConstraints}" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" id="RemoveTests"
						action="#{pc_RoleEntitlements.deleteRoleTests}" disabled="#{pc_RoleEntitlements.noUpdateTests || empty pc_RoleEntitlements.testEntries}" />
					<h:outputText id="sepText" value=" | " styleClass="actionSeparator" />
					<hx:commandExButton type="submit" value="#{bundle.button_addConstraint}" id="addRoleTest" action="#{pc_RoleEntitlements.addRoleTest}" 
						disabled="#{pc_RoleEntitlements.noUpdateTests}" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif"/>
					</h:panelGroup>	
			</div>
				
			<div class="primarySectionHeader">
				<h2><ram:infopop id="classInfopop" styleClass="jazz-app-ua-TextHoverHelp" contextId="tsrc0030" text="#{bundle.section_roleClass_scope}" /></h2>
			</div>
			<h:outputText id="section_help3" styleClass="sectionInstructions"
				value="#{bundle.help_section_roleClass_scope}" />
				
			<table class="formTable" cellspacing="3">
				<tbody>
					<tr>
						<td class="label" style="white-space: nowrap; padding: 6px 0"><h:outputText id="roleClassScopeApplies" value="#{bundle.label_roleClass_scope_applies} " /></td>
						<td class="input">
							<h:selectOneRadio layout="lineDirection" id="andOrRadiosUserClass" disabled="#{pc_RoleEntitlements.userClassTestEntriesCt <= 1}" 
							value="#{pc_RoleEntitlements.userClassTestsRoot.andOr}" binding="#{pc_RoleEntitlements.userClassAndOrRadios}">
								<f:selectItem id="selectAndUserClass" itemValue="and" itemLabel="#{bundle.option_role_scope_all}" />
								<f:selectItem id="selectOrUserClass" itemValue="or" itemLabel="#{bundle.option_role_scope_atLeast}" />
							</h:selectOneRadio>
						</td>
					</tr>
				</tbody>
			</table>
			
			<hx:dataTableEx border="0"
				rowClasses="oddRow, evenRow" id="userClassTestsTable" styleClass="displayTable secondaryTable" columnClasses="selectColumn, noClass, noClass, noClass, noClass"
				value="#{pc_RoleEntitlements.userClassTestEntries}" var="vartestEntries"
				summary="#{bundle.alt_table_role_scope}">
				
				<hx:columnEx id="ucColumnEx1" nowrap="true">
					<f:facet name="header">
						<hx:outputSelecticons id="ucSelecticons2"  for="userClassTestsTable" styleClass="selectIcons"
							srcInverse="#{pc_RoleEntitlements.nullImage}"
							srcAll="#{pc_RoleEntitlements.checkAllImage}" 
							srcNone="#{pc_RoleEntitlements.checkNoneImage}" />
					</f:facet>					
					<hx:inputRowSelect value="#{vartestEntries.selected}" id="ucSelectedTest" 
						srcSelected="#{pc_RoleEntitlements.checkedBoxImage}"
						srcUnselected="#{pc_RoleEntitlements.uncheckedBoxImage}" />
				</hx:columnEx>
				<hx:columnEx id="ucTestTypeCol" width="20%">
					<f:facet name="header"><h:outputText id="ucTestTypeHead" value="#{bundle.column_type}" /></f:facet>
					<h:outputText id="ucTestTypeVal" value="#{vartestEntries.testTypeDisplayName}"/>
				</hx:columnEx>
				<hx:columnEx id="ucNotCol" width="10%" style="white-space: nowrap">
					<h:outputText id="ucNotString" value="#{vartestEntries.notString}" />
				</hx:columnEx>
				<hx:columnEx id="ucMatchTypeCol" width="20%" style="white-space: nowrap">
					<h:outputText id="ucMatchType" value="#{vartestEntries.matchTypeString}" />
				</hx:columnEx>				
				<hx:columnEx id="ucValCol" width="50%">
					<f:facet name="header"><h:outputText id="ucValHead" value="#{bundle.column_expression}" /></f:facet>
					<h:outputText id="ucValText" value="#{vartestEntries.expression}"/>
				</hx:columnEx>
			</hx:dataTableEx>
			
			<div class="secondaryActionGroup">
				<h:panelGroup id="uctestConstraintPanel">
					<hx:ajaxRefreshSubmit id="ajaxrefresh2" />
					<ram:messagesEx id="ucmessages" for="ucNew" />
					<hx:commandExButton type="submit" value="#{bundle.button_removeConstraints}" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" id="ucRemoveTests"
						action="#{pc_RoleEntitlements.ucDeleteRoleTests}" disabled="#{pc_RoleEntitlements.noUpdateTests || empty pc_RoleEntitlements.userClassTestEntries}" />
					<h:outputText id="ucsepText" value=" | " styleClass="actionSeparator" />
					<h:outputText id="ucNew" value="#{bundle.role_test_userclass_type}" style="width:auto; margin-right: 3px"/>
					<h:selectOneMenu id="ucNewNotString" value="#{pc_RoleEntitlements.userClassNewTest.notString}" 
						styleClass="shortSelect" style="width:auto; margin-right: 3px"
						title="#{bundle.alt_role_test_condition}">
						<f:selectItem id="ucNewMust" itemValue="option_must_be" itemLabel="#{bundle.option_must_be}" />
						<f:selectItem id="ucNewMustNot" itemValue="option_must_not_be" itemLabel="#{bundle.option_must_not_be}" />
					</h:selectOneMenu>
	
					<h:selectOneMenu id="ucNewMatchType" value="#{pc_RoleEntitlements.userClassNewTest.matchType}"
						converter="ram.converter.Standard"
						styleClass="shortSelect" style="width:auto; margin-right: 3px"
						title="#{bundle.alt_role_matchType}">
						<f:selectItems id="ucNewMatchTypes" value="#{pc_RoleEntitlements.userClassNewTest.matchTypes}" />
					</h:selectOneMenu>
										
					<h:inputText id="ucNewExpression" value="#{pc_RoleEntitlements.userClassNewTest.expression}" styleClass="longField" title="#{bundle.alt_role_userClass_value}" style="margin-right: 3px"/>
										
					<hx:commandExButton type="submit" value="#{bundle.button_addConstraint}" id="ucAddRoleTest" action="#{pc_RoleEntitlements.ucAddRoleTest}"  
						disabled="#{pc_RoleEntitlements.noUpdateTests}" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif"/>
				</h:panelGroup>				
			</div>

			<div class="primaryActionGroup">
				<hx:commandExButton
					type="submit" value="#{bundle.button_ok}"
					styleClass="commandExButton"
					iconDepressed="/theme/images/transparent.gif" id="UpdateRole"
					action="#{pc_RoleEntitlements.updateRole}" />
				<hx:commandExButton 
					type="submit" value="#{bundle.button_cancel}"
					id="cancelUpdate" styleClass="commandExButton"
					iconDepressed="/theme/images/transparent.gif"
					action="#{pc_RoleEntitlements.cancelUpdate}" />
			</div>

			<ram:context id="ramgid1" name="gid"></ram:context>
				<ram:context name="rid" id="ramrid1" defaultValue="#{pc_RoleEntitlements.role.id}"></ram:context>
				
			</ram:form>
			
			</div>
			</div>
			
			<%@include file="/theme/footer.jspf" %>
		</hx:scriptCollector>
	</body>
</f:view>
</html>