<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/assetDetail/ReviewDetails.java" --%><%-- /jsf:pagecode --%>

<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2009. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  -----------------------------------------------------------------------------%>

<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>
<%@ page import="java.util.ResourceBundle" %>
<html>
<head>
	<%@ include file="/theme/metaHeader.jspf" %>
	<%@include file="/theme/cssHideRightShowLeftColumn.jspf"%>
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/categorize_tree.js"></script>
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/lifecycle_visualization.js"></script>
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/ckeditor/ckeditor.js"></script>
	
	<% String actualLocale = ResourceBundle.getBundle("com.ibm.ram.repository.web.bundles.webMessages", request.getLocale()).getLocale().toString().replace('_', '-'); %>
	
	<link rel="alternate" type="application/rss+xml" title="${bundle.asset_feed}" href="${pc_ReviewDetails.feedUrl}" />
	<link rel="csh" href="${applicationScope.cshPath}">
	<title>${pc_ReviewDetails.browserTitle}</title>
	
	

	<%-- Dojo layer imports  --%>
	${pc_ReviewDetails.JSLayers['ram/layers/LifecycleCollaboration']}
	${pc_ReviewDetails.JSLayers['ram/layers/ReviewBar']}

	<script type="text/javascript">
		dojo.require('dojo.parser');
		dojo.require('ram.RamDialog');
		dojo.require('dijit.form.Button');
		dojo.require('dijit.Menu');
		dojo.require('dijit.form.NumberSpinner');
		dojo.require('dijit.layout.ContentPane');
		dojo.require('dijit.layout.BorderContainer');
		dojo.require('dijit.Editor');
	    dojo.require('dijit.TitlePane');
	    dojo.require('dijit._editor.plugins.TextColor');
	    dojo.require('dijit._editor.plugins.LinkDialog');
		dojo.require('ram.ConditionBuilder');
		dojo.require('ram.ConditionSummaries');
		dojo.require('ram.categorytree.CategoryTree');
		dojo.require('dijit.layout.TabContainer');
		dojo.require('dijit.layout.ContentPane');
		dojo.require('dojo.fx');
		dojo.require('ram.ConditionToDo');
//		dojo.registerModulePath('ram', '../ram');
		dojo.require('dojo.i18n');
		dojo.requireLocalization('ram', 'lifecycleeditor');

		var bundle = dojo.i18n.getLocalization('ram', 'lifecycleeditor');
		
		function showLoadingDialog(callback) {
			var loadingDialog = dijit.byId('lifecycle_editor_loading_dialog');
			if (!loadingDialog) {
				loadingDialog = new ram.RamDialog({id: 'lifecycle_editor_loading_dialog', title: bundle.loading});
				dojo.style(loadingDialog.domNode, 'minWidth', '300px');
				dojo.place(loadingDialog.domNode, dojo.body());
				loadingDialog.attr('content', '<div><img style="vertical-align: text-bottom; margin-right: 3px" src="' + getAbsoluteUrl('theme/images/icon_animated_busy.gif') + '">' + bundle.loading + '</div>');
				if (callback)
					loadingDialog.onOpen = callback;
			}
			loadingDialog.show(true);
		}
		
		function hideLoadingDialog() {
			var loadingDialog = dijit.byId('lifecycle_editor_loading_dialog');
			if (loadingDialog)
				loadingDialog.hide();
		}

		var VISUAL_LIFECYCLE_URL = "internal/service/VisualLifecycleService.getJSONVisualLifecycle"

		function showAndLoadEditor(addCollab) {
			showLoadingDialog(function() {
				// this function is set as the loading dialog's onOpen function, because we want to show the loading 
				// dialog first then open the editor, otherwise the dialog doesn't open until after the editor opens
				if (dojo.style('lifecycle_editor', 'display') != 'block') {
					hideDiagram();
					initialize();
					dojo.style('lifecycle_editor', 'display', 'block');
					resizeEditor();
				}
				hideLoadingDialog();
				if (addCollab) {
					showAddCollaboratorDialog(ROLE_CAN_VIEW);
				}
			});
		}
		
		function parseURL() {
			var hash = location.hash;
			if(hash == '#loadEditor') {
				showAndLoadEditor(false); 
			} else if (hash == '#addCollaborator') {
				showAndLoadEditor(true);
			} else if (hash == '#addConsumer') {
				showAndLoadEditor(false);
				var select = dojo.byId("workflowElements");
				select.selectedIndex = 0;
				event_selectWorkflowElement();
			}
		}

		function hideDiagram() {
			var splitter = document.getElementById('diagramContainer_splitter');
			if(splitter!=null)
				splitter.style.display = 'none';
			var container = document.getElementById('diagramContainer');
			if(container!=null)
				container.style.display = 'none';
			document.getElementById('loadDiagramDiv').style.display = '';
		}

		function showDiagram() {
			var lifecycleId = document.getElementById('mainForm:lifecycleId').value;
			var communityId = document.getElementById('mainForm:communityId').value;
			var visualLifecycleJson;
			dojo.xhrGet({
				url: getAbsoluteUrl(VISUAL_LIFECYCLE_URL + "?assetLifecycleId=" + lifecycleId + "&resourceGroupId=" + communityId),
				handleAs: "text",
				sync: true,
				load: function(response, ioArgs) {
				visualLifecycleJson = response;
				},
				// The ERROR function will be called in an error case.
				error: function(response, ioArgs) {
					console.error("HTTP status code: ", ioArgs.xhr.status);
					visualLifecycleJson = null;
				}
			});
			
			var appletHeight = document.getElementById('borderContainer').offsetHeight;
			document.lifecycleApplet.height = parseInt(appletHeight) + 'px';
			document.getElementById('diagramContainer_splitter').style.display = 'inline';
			
			document.getElementById('diagramContainer').style.display = 'inline';
			var split = dijit.byId('borderContainer');
			if(split != null) {
				split.layout();
			}
			document.getElementById('loadDiagramDiv').style.display = 'none';
			resizeEditor();
			if (navigator.appName.indexOf("Microsoft") == -1) {
				document.lifecycleApplet.width = '100%'; 
			}
			loadLifecycle(visualLifecycleJson);
		}

		function resizeEditor() {
			var currentEditorHeight = document.getElementById('editorContainer').scrollHeight;
			var currentSplitContainerHeight = document.getElementById('borderContainer').offsetHeight;
			if(currentEditorHeight > currentSplitContainerHeight) {
				var container = dijit.byId('borderContainer');
				var containerHeight = currentEditorHeight + 20;
				if(container != null) {
					var containerWidth = '100%';
					container.resize({w:containerWidth,h:containerHeight,l:0,t:0});
				} else {
					var editor = document.getElementById('borderContainer');
					if(editor != null) {  
						editor.style.height = parseInt(containerHeight) + 'px';
					} 
				}
				if(document.lifecycleApplet != null){
					document.lifecycleApplet.height = containerHeight;
				}			
			} else {
				var container = dijit.byId('borderContainer');
				if (container) {
					var containerWidth = '100%';
					container.resize({w:containerWidth,h:currentSplitContainerHeight,l:0,t:0});
				}
			}
			if (navigator.appName.indexOf("Microsoft") >= 0) {
				document.getElementById('editorContainer').style.overflow = 'visible';
			}
		}

		function setDiagramWidth() {
			if(document.getElementById('diagramContainer').style.display != 'none' && document.lifecycleApplet.width == '150') {
				document.lifecycleApplet.width = '100%';
			}
		}
		
		var submitted=false;
		function formSubmitted() {
			if(submitted) {
				return false;
			} else {
				submitted = true;
				return true;
			}
		}
		
		function getComment(dialog,textArea){			
			if(dojo.byId(dialog) != null){
				var comment = dojo.byId(dialog).value;
				dojo.byId(textArea).value = comment;
			}
			
		}
	</script>
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/lifecycle_editor.js"></script>


	<style>
		.ram .dijitSplitterV,
		.ram .dijitGutterV {
			background-color: #EFEEF6;
		}
		
		.dijitSplitterCover{
 			opacity:0;
		}
		
		#borderContainer {
    		height: 300px;
  		}
	
		select.result {
			width: 100%;
		}
		
		.workflowElementDescription {
			color: #67555C;
		}
		td.checkboxColumn {
			text-align: center;
		}
		td.nowrapCell {
			white-space: nowrap;
		}		
		#workflowElements {
			margin-right: 5px;
		}
		.state-configs {
			margin: 10px 0;
		}
		.radio_option {
			margin: 5px 0;
		}
		#override_permissions, #no_override_permissions, #readonly_permissions {
			margin: 5px 0px 0;
		}
		
		.buttons-bar {
			margin: 10px 0;
		}
		
		.buttons-bar input.commandExButton {
			margin-right: 5px;
		}
		
		#voting_restart {
			margin-top: 10px;
		}
		
		.editor-section {
			margin: 10px 0 40px;
		}
		
		.secondaryActionGroup {
			margin-bottom: 0px;
		}
		
		.primarySectionContent {
			margin: 5px;
		}
		
		table.displayTable table td {
			border-style: hidden;
			border-width: 0px 0px 1px;
			padding: 0px;
		}
		
		.asset-section table.secondaryActionGroup tr {
			background-color: transparent;
		}
		
		#pending_asset_help {
			margin: 15px 0 0 19px;
			display: block;
		}
		
		#pending_asset_help a, #pending_asset_help a:hover {
			color: #787878;
			border-bottom: 1px dotted #787878;
			text-decoration: none;
		}
		
		.radio {
			margin: 0 5px 0 0;
		}
		
		.approved, .rejected {
			background-position: left center;
			background-repeat: no-repeat;
			padding-left: 20px;
			display: block;
		}
		
		.approved {
			background-image: url(${pageContext.request.contextPath}/theme/images/icons/obj16/review-approved.gif);
		}
		.rejected {
			background-image: url(${pageContext.request.contextPath}/theme/images/icons/obj16/review-rejected.gif);
		}
		
	</style>
	<script type="text/javascript">
		dojo.addOnLoad(function(){
			fetchAttributeData();
		});
	</script>
</head>
<f:view>
	<body class="ram" onload="hideDiagram();parseURL();">
	<hx:scriptCollector id="scriptCollector1">

		<%@ include file="/includes/assetDetailSideBar.jspf" %>
		<div id="waitingPanel" style="display:none;">
				<h:panelGroup id="loading_tab_animation" style="text-align:center;">		
					<h:graphicImage id="animatedBusyIcon" 
							value="/theme/images/icon_animated_busy.gif" alt="#{bundle.alt_loading_icon}"/>		
				</h:panelGroup>
				<td>Loading...</td>
		</div>
		<ram:infopop id="pageHelp" for="assetName" styleClass="pageHelp" image="/theme/images/icons/obj16/info_indicator.gif" contextId="agdc0001"/>
		<div id="contentColumn">
		
		<ram:form id="selectGroupDialogForm1">
			<h:inputHidden id="commentTextArea" value="#{pc_ReviewDetails.lifecycleReviewComment}"></h:inputHidden>
			<hx:panelDialog id="selectGroupDialog" rendered="#{pc_ReviewDetails.showStatusBar }"
			type="modeless" align="center" valign="middle"
			styleClass="panelDialog" style="width:300px;"
			for="mainForm:currentAssetHistoryIterator:0:reviewCommentGroupApproveButton" title="#{bundle.lifecycle_vote_for_groups}">
				<h:panelGroup id="selectGroupDialogGroup" style="width:300px">
					<h:outputText id="reviewInfo" value="#{bundle.lifecycle_vote_info}"/>
						<hx:dataTableEx id="selectGroupDialogTable" styleClass="displayTable" 
							value="#{pc_ReviewDetails.groupVoteWrapper}" var="groupVoteWrapper" style="margin-top: 15px;">
							<hx:columnEx id="selectGroupDialogCheckCol">
						    	<h:graphicImage id="approveImage" value="/theme/images/icons/obj16/review-approved.gif" rendered="#{groupVoteWrapper.approve}"
											style="vertical-align: middle; margin-left: 5px; margin-right: 3px; margin-top: -2px;"></h:graphicImage>
							    <h:graphicImage id="rejectImage" value="/theme/images/icons/obj16/review-rejected.gif" rendered="#{groupVoteWrapper.reject}"
											style="vertical-align: middle; margin-left: 5px; margin-right: 3px; margin-top: -2px;"></h:graphicImage>
								<h:selectBooleanCheckbox 
									rendered="#{!groupVoteWrapper.approve && !groupVoteWrapper.reject}"
									id="selectGroupDialogCheckBox" value="#{groupVoteWrapper.approve}">
								</h:selectBooleanCheckbox>
							</hx:columnEx>
							<hx:columnEx id="selectGroupDialogTextCol" >
								<h:outputText
									id="selectGroupDialogText" value="#{groupVoteWrapper.groupName}">
								</h:outputText>
							</hx:columnEx>
						</hx:dataTableEx>
				<h:panelGroup id="selectGroupDialogActionGroup" styleClass="dialogActionGroup">
					<hx:commandExButton
						action="#{pc_ReviewDetails.doApproveAsset}"
						styleClass="commandExButton"
						type="submit"
						onclick="getComment(\"mainForm:currentAssetHistoryIterator:0:commentTextArea\",\"selectGroupDialogForm1:commentTextArea\")"
						id="approve_button" value="#{bundle.button_approve}">
					<f:param id="approveButtonGuidParam" name="guid" 
						value="#{pc_ReviewDetails.asset.id}" />
					<f:param id="approveButtonVersionParam" name="v"
						value="#{pc_ReviewDetails.asset.version}" />
					<f:param id="approveButtonSubmissionButton" name="submission"
						value="#{pc_ReviewDetails.asset.submissionAsset }" />
					</hx:commandExButton>
					<hx:commandExButton id="selectGroupDialogCancel"
						styleClass="commandExButton"
						iconDepressed="/theme/images/transparent.gif" type="reset"
						value="#{bundle.button_cancel}">
						<hx:behavior id="selectGroupDialogCancelBehavior" event="onclick" 
							behaviorAction="hide;stop" targetAction="selectGroupDialog" />
					</hx:commandExButton>
				</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
			<ram:context id="guidSelectReviewGroup" name="guid" defaultValue="#{pc_ReviewDetails.asset.id}"/>
			<ram:context id="versionSelectReviewGroup" name="v" defaultValue="#{pc_ReviewDetails.asset.version}" />
			<ram:context id="submissionSelectReviewGroup" name="submission" defaultValue="#{pc_ReviewDetails.asset.submissionAsset}" />
			<ram:context id="topicSelectReviewGroup" name="tid" />
			<ram:context id="forumSelectReviewGroup" name="fid" />
			<ram:context id="postCSelectReviewGroup" name="post" />
		</ram:form>
		
		<ram:form id="rejectGroupDialogForm1">
			<h:inputHidden id="commentTextArea" value="#{pc_ReviewDetails.lifecycleReviewComment}"></h:inputHidden>
			<hx:panelDialog id="rejectGroupDialog" rendered="#{pc_ReviewDetails.showStatusBar }"
			 type="modeless" align="center" valign="middle"
		 	 styleClass="panelDialog" style="width:300px;"
			 for="mainForm:currentAssetHistoryIterator:0:reviewCommentGroupRejectButton" title="#{bundle.lifecycle_reject_for_groups}">
				<h:panelGroup id="rejectGroupDialogGroup" style="width:300px">
					<h:outputText id="reviewInfo" value="#{bundle.lifecycle_vote_info}"/>
						<hx:dataTableEx id="rejectGroupDialogTable" styleClass="displayTable" 
							value="#{pc_ReviewDetails.groupVoteWrapper}" var="groupVoteWrapper" style="margin-top: 15px;">
							<hx:columnEx id="rejectGroupDialogCheckCol">
							
								<h:graphicImage id="approveImage" value="/theme/images/icons/obj16/review-approved.gif" rendered="#{groupVoteWrapper.approve}"
											style="vertical-align: middle; margin-left: 5px; margin-right: 3px; margin-top: -2px;"></h:graphicImage>
							    <h:graphicImage id="rejectImage" value="/theme/images/icons/obj16/review-rejected.gif" rendered="#{groupVoteWrapper.reject}"
											style="vertical-align: middle; margin-left: 5px; margin-right: 3px; margin-top: -2px;"></h:graphicImage>
								<h:selectBooleanCheckbox
									rendered="#{!groupVoteWrapper.approve && !groupVoteWrapper.reject}" 
									id="rejectGroupDialogCheckBox" value="#{groupVoteWrapper.reject}">
								</h:selectBooleanCheckbox>
							</hx:columnEx>
							<hx:columnEx id="rejectGroupDialogTextCol" >
								<h:outputText
									id="rejectGroupDialogText" value="#{groupVoteWrapper.groupName}">
								</h:outputText>
							</hx:columnEx>
						</hx:dataTableEx>
				<h:panelGroup id="rejectGroupDialogActionGroup" styleClass="dialogActionGroup">
					<hx:commandExButton
						action="#{pc_ReviewDetails.doRejectAsset}"
						styleClass="commandExButton"
						type="submit"
						onclick="getComment(\"mainForm:currentAssetHistoryIterator:0:commentTextArea\",\"rejectGroupDialogForm1:commentTextArea\")"
						id="reject_button" value="#{bundle.button_reject}">
					<f:param id="rejectButtonGuidParam" name="guid" 
						value="#{pc_ReviewDetails.asset.id}" />
					<f:param id="rejectButtonVersionParam" name="v"
						value="#{pc_ReviewDetails.asset.version}" />
					<f:param id="rejectButtonSubmissionButton" name="submission"
						value="#{pc_ReviewDetails.asset.submissionAsset }" />
					</hx:commandExButton>
					<hx:commandExButton id="rejectGroupDialogCancel"
						styleClass="commandExButton"
						iconDepressed="/theme/images/transparent.gif" type="reset"
						value="#{bundle.button_cancel}">
						<hx:behavior id="rejectGroupDialogCancelBehavior" event="onclick" 
							behaviorAction="hide;stop" targetAction="rejectGroupDialog"></hx:behavior>
					</hx:commandExButton>
				</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
			<ram:context id="guidRejectReviewGroup" name="guid" defaultValue="#{pc_ReviewDetails.asset.id}"/>
			<ram:context id="versionRejectReviewGroup" name="v" defaultValue="#{pc_ReviewDetails.asset.version}" />
			<ram:context id="submissionRejectReviewGroup" name="submission" defaultValue="#{pc_ReviewDetails.asset.submissionAsset}" />
			<ram:context id="topicRejectReviewGroup" name="tid" />
			<ram:context id="forumRejectReviewGroup" name="fid" />
			<ram:context id="postCRejectReviewGroup" name="post" />
		</ram:form>
		
		<div class="inside">
			<ram:form id="mainForm" onsubmit="return formSubmitted();">
		
			<div style="text-align: right">
				<h:graphicImage id="editLifecycleLinkBusyIcon" value="/theme/images/icon_animated_busy.gif"
					style="vertical-align: middle; display:none;" alt="#{bundle.alt_loading_icon}" />
				<h:outputLink id="editLifecycleLink" value="javascript:showAndLoadEditor();" rendered="#{pc_ReviewDetails.reviewBoardMember}" 
					title="#{bundle.lifecycle_alt_edit_configuration}">
					<h:outputText id="editLifecycleText" value="#{bundle.lifecycle_alt_edit_configuration}"></h:outputText>
				</h:outputLink> 
			</div>  
			
			<div id="lifecycle_editor" class="ram-section asset-section lifecycle-editor" style="display: none;">
				<div class="top-section">
					<div class="header">
						<div style="display: block;" class="header-text-no-icon">
						</div>
						<div class="header-buttons" style="margin-top: 2px;">
							<input type="button" class="commandExButton" onclick="event_saveLifecycle();" value="${bundle.button_save}" style="float: left;" />
							<input type="button" class="commandExButton" onclick="event_cancelEditorChanges();hideDiagram();" value="${bundle.button_cancel}" style="float: left; margin-left: 5px;"/>
							<ram:infopop id="lifecycleEditorHelp" styleClass="viewletInfopop" contextId="agdc0300" />
						</div>
						<div id="loadDiagramDiv" style="margin-top: 3px; margin-left: 10px; font-weight: normal;">
							<a href="#" class="moreLink" onclick="showDiagram();">${bundle.lifecycle_link_load_diagram}</a>
						</div>
						<h:inputHidden id="lifecycleId" value="#{pc_ReviewDetails.lifecycleId}"></h:inputHidden>
						<h:inputHidden id="communityId" value="#{pc_ReviewDetails.communityId}"></h:inputHidden>
					</div>
				</div>
				<div class="middle-section">
					<div class="content-wrapper">
						<div class="content">
							
							<div id="editor">
							<div dojoType="dijit.layout.BorderContainer" design="sidebar" gutters="false" 
								liveSplitters="true" id="borderContainer">
						
								<div id="diagramContainer" dojoType="dijit.layout.ContentPane" splitter="true" region="leading" 
									style="width: 150px; display: none;" onclick="resizeEditor();">
									<div id="diagram">
								          <ram:lifecycleVisualization id="lifecycleVisualization" editable="true" value=""></ram:lifecycleVisualization>
								    </div>
							  	</div>
							  	
							  	<div id="editorContainer" dojoType="dijit.layout.ContentPane" splitter="true" region="center" style="margin-left: 5px; width: 100%;" 
							  		onclick="resizeEditor();" onmouseover="setDiagramWidth();">
									
								    	<div id="editor_nav">
								    		<h:outputText id="instructAssetLifecycleConfig" value="#{bundle.help_asset_lifecycle_section_configuration}" styleClass="sectionInstructions"/>
								    		<table class="panelFormBox" border="0" style="margin: 10px 0;">
								    			<tbody>
									    			<tr>
									    				<td class="panelFormBox_Label-Cell">
									    					<label for="masterLifecycle">${bundle.label_master_lifecycle}</label>
									    				</td>
									    				<td>
									    					<div id="masterLifecycle">${bundle.text_none}</div>
									    				</td>
									    			</tr>
								    			</tbody>
							    			</table>
								    		<table border="0" cellspacing="0">
						    					<tr style="background-color: #E5EFF5">
								    				<td class="panelFormBox_Label-Cell nowrapCell">
								    					<label class="label" for="workflowElements">${bundle.label_lifecycle_nav}</label>
								    				</td>
								    				<td width="100%">
								    					<select id="workflowElements" onchange="document.getElementById('workflowElementsButton').disabled=false;"></select>
								    					<input id="workflowElementsButton" type="button" onclick="event_selectWorkflowElement();this.disabled=true;" 
								    						value="${bundle.button_go}" disabled="true">
								    					<span id="private_state_config" style="display: none;">
								        					<input style="vertical-align: middle; margin-left: 20px;" id="private_state_config_checkbox" type="checkbox" onclick="setPrivateCollaboration(this);"/>
								        					<img style="vertical-align: text-top;" src="<%=request.getContextPath() +  "/theme/images/icons/obj16/statusLocked.gif"%>"/>
								        					<ram:textHoverHelp id="private_state_config_checkbox_label" value="#{bundle.label_lifecycle_private_collaboration}" helpContentString="#{bundle.help_lifecycle_private_review}" />
								        					<span id="private_state_config_checkbox_inherited_text" class="inherited" style="margin-left: 5px; display: none;">
									        					(<ram:textHoverHelp id="private_state_config_checkbox_inherited_text_hover" 
									        						value="#{bundle.label_inherited}" helpContentString="#{bundle.help_lifecycle_inherited}"/>)
								        					</span>
							        					</span>
								    				</td>
								    			</tr>
								    			<tr>
								    				<td></td>
								    				<td><div id="workflowElementDescription" class="workflowElementDescription" style="display: none;"></div></td>
								    			</tr>
								    			<tr>
								    				<td></td>
								    				<td><div id="aligned-configs"></div></td>
								    			</tr>
								    		</table>
								    	</div>
								    	<div>
								    		<span id="lifecycleCommentSpan" style="display: none;margin-right:10px;"><input type="checkbox" id="lifecycleComment" class="checkboxText"  onclick="lifecycleCommentFieldChanged(this);"/> 
							    				<label class="checkboxText" for="lifecycleComment" id="lifecycleCommentLabel">${bundle.label_comments_desc}</label>
							    				<span id="comment_checkbox_inherited_text" class="inherited" style="margin-left: 5px; display: none;">
										         (<ram:textHoverHelp id="comment_checkbox_inherited_text_hover" 
										          value="#{bundle.label_inherited}" helpContentString="#{bundle.help_lifecycle_inherited}"/>)
									            </span>
							    			</span>
								    	</div>
								    	<div id="lifecycle">			    		
								    		<div id="add_lifecycle_configs"></div>	  
								    		<div id="lifecycle_conditions" class="editor-section"></div>
								    		<div id="review_board" class="editor-section"></div>
								    		<div id="collaborators" class="editor-section"></div>
								    	</div>
								    	<div id="state" style="display:none">
								        	<div id="state_advanced" class="editor-section" style="display:none"></div>
								        	<div id="state_users" class="editor-section" style="display:none"></div>
									        <div id="policy_state_config" class="editor-section" style="display:none"></div>
										</div>
										<div id="transition" style="display: none">
											<div id="add_transition_configs"></div>
											<div id="transition_conditions" class="editor-section"></div>
										</div>
										<div id="loading_editor" style="display: none; text-align: center; margin: 100px 0;">
											<img src="<%=request.getContextPath() +  "/theme/images/icon_animated_busy.gif"%>" alt="#{bundle.alt_loading_icon}"/>
											<span style="margin-left: 5px;">Loading...</span>
										</div>
								    </div>
								</div>
						    
						    </div>
						    <div class="header-buttons" style="float:right; position: static;">
								<input type="button" class="commandExButton" onclick="event_saveLifecycle();" value="${bundle.button_save}" style="float: left;" />
								<input type="button" class="commandExButton" onclick="event_cancelEditorChanges();hideDiagram();" value="${bundle.button_cancel}" style="margin-left: 5px;"/>
							</div>
						</div>
					</div>
				</div>
				<div class="bottom-section">
					<div class="bottom-right"></div>
				</div>
			</div>
			<h:inputHidden value="#{pc_ReviewDetails.showSearchScopeOption}" id="searchLDAP" />

			<h:inputHidden id="approvedCount" value="#{pc_ReviewDetails.approvedCount}"/>
			<h:inputHidden id="rejectedCount" value="#{pc_ReviewDetails.rejectedCount}"/>
			<h:inputHidden id="awaitingCount" value="#{pc_ReviewDetails.awaitingCount}"/>
			
			<h:inputHidden id="countedVotes" value="#{pc_ReviewDetails.countedVotes}"/>
			
			<script type="text/javascript">
				function showSummary(element, detailElementId) {
					element.style.display = 'none';
					document.getElementById(element.id.replace('ShowSummary','HideSummary')).style.display = '';
					document.getElementById(detailElementId).style.display = '';
				}

				function hideSummary(element, detailElementId) {
					element.style.display = 'none';
					document.getElementById(element.id.replace('HideSummary','ShowSummary')).style.display = '';
					document.getElementById(detailElementId).style.display = 'none';
				}

				function toggleChildEvents(element) {
					var tableElement = element.parentNode.nextSibling;
					if(tableElement.style == null) {
						tableElement = tableElement.nextSibling;
					}
					if(tableElement.style.display == 'none') {
						tableElement.style.display = 'block';
					} else {
						tableElement.style.display = 'none';
					}
					var parent = element.parentNode;
					element.style.display = 'none';
					if (element.id == 'showChildEvents') {
						for(var i = 0; i < parent.children.length; i++) {
							if(parent.children[i].id == 'hideChildEvents') {
								parent.children[i].style.display = '';
								break;
							}
						}
					} else {
						for(var j = 0; j < parent.children.length; j++) {
							if(parent.children[j].id == 'showChildEvents') {
								parent.children[j].style.display = '';
								break;
							}
						}
					}
				}
			</script>
			
			<div style="margin-top: 10px">
				<hx:dataIterator id="currentAssetHistoryIterator" value="#{pc_ReviewDetails.currentAssetHistory}" var="currentAssetHistory">
					<hx:jspPanel id="currentStateHeaderPanel">
						<div class="assetCallOutBorder"></div>
						<div id="currentStateStatusBar" class="assetCallOut" style="height: 100%; min-height: 20px;">
							<div style="margin: 2px 0px 10px 6px;">
							
								<hx:jspPanel id="currentStateHistoryStatusLinkPanel" rendered="#{currentAssetHistory.authorized}">
									<span style="float: right;">
										<h:outputLink id="currentShowSummary" value="javascript: void(0);" onclick="javascript:showSummary(this, 'currentStateDetail');return false" style="padding-right: 5px;">
											<h:outputText id="currentShowSummaryText" value="#{bundle.lifecycle_show_status}"></h:outputText>
										</h:outputLink>
										<h:outputLink id="currentHideSummary" value="javascript: void(0);" onclick="javascript:hideSummary(this, 'currentStateDetail');return false" style="padding-right: 5px; display: none;">
											<h:outputText id="currentHideSummaryText" value="#{bundle.lifecycle_hide_status}"></h:outputText>
										</h:outputLink>
									</span>
								</hx:jspPanel>
								<ram:infopop id="currentStateStatusBarHelp" styleClass="jazz-app-ua-TextHoverHelp assetCallOutFont" contextId="agdc0200" text="#{currentAssetHistory.tableHeader}"/>
								<hx:jspPanel id="currentPrivateCollaborationLockNotAuthorized" rendered="#{currentAssetHistory.privateReview && !currentAssetHistory.authorized}">
									<img style="margin-left: 5px" src="<%=request.getContextPath() + "/theme/images/icons/obj16/statusLocked.gif"%>" align="top"
										alt="${bundle.label_private_collaboration_state_not_authorized}" title="${bundle.label_private_collaboration_state_not_authorized}"></img>
								</hx:jspPanel>
								<hx:jspPanel id="currentPrivateCollaborationLockAuthorized" rendered="#{currentAssetHistory.privateReview && currentAssetHistory.authorized}">
									<img style="margin-left: 5px" src="<%=request.getContextPath() + "/theme/images/icons/obj16/statusLocked.gif"%>" align="top"
										alt="${bundle.label_private_collaboration_state_authorized}" title="${bundle.label_private_collaboration_state_authorized}"></img>
								</hx:jspPanel>								
								
								<hx:jspPanel id="currentStateDetailPanel" rendered="#{!currentAssetHistory.privateReview || currentAssetHistory.authorized}">
									<div id="currentStateDetail" style="clear: both; margin-top: 10px; margin-left: 5px; display: none;">
										<div style="background-color: #FFFFFF; border: 1px solid #DDDDDD; padding: 5px; margin: 0 10px 10px 0">
											<div style="float: left; margin-right: 60px;">
												<h:outputText style="font-weight: bold;" id="currentApprovingUsersText" value="#{currentAssetHistory.approvingUsersText}"></h:outputText>
												<hx:dataTableEx  id="currentApprovingUsersTable" value="#{currentAssetHistory.approvingUsers}" var="currentApproveUser" border="0" cellpadding="2">
													<hx:columnEx id="currentApprovingUserIconColumn" width="15px" align="right">
														<h:graphicImage id="currentApproverImage" value="#{currentApproveUser.imageURL}" 
															width="15" height="15" alt="#{currentApproveUser.name}"/>
													</hx:columnEx>
													<hx:columnEx id="currentApprovingUserNameColumn">
														<ram:resourceOutputLink styleClass="outputLink" uri="/oslc/users/#{currentApproveUser.identifier}" value="#{pc_ReviewDetails.pageContext}/secure/userDetail.faces" id="approveUserLink">
															<f:param id="currentApproveUserIdParam" name="uid" value="#{currentApproveUser.identifier}" />
															<h:outputText id="currentApproveUserName" styleClass="outputText" value="#{currentApproveUser.name}"/>
														</ram:resourceOutputLink>
														<ram:externalProfile id="currentUserDetailExternal" value="#{currentApproveUser.identifier}" />
													</hx:columnEx>
												</hx:dataTableEx>
											</div>		
											
											<div style="float: left; margin-right: 60px;">
												<h:outputText style="font-weight: bold;"  id="currentRejectingUsersText" value="#{currentAssetHistory.rejectingUsersText}"></h:outputText>
												<hx:dataTableEx  id="currentRejectingUsersTable" value="#{currentAssetHistory.rejectingUsers}" var="currentRejectingUser" border="0" cellpadding="2">
													<hx:columnEx id="currentRejectingUserUconColumn" width="15px" align="right">
														<h:graphicImage id="currentRejectingUserImage" value="#{currentRejectingUser.imageURL}" 
															width="15" height="15" alt="#{currentRejectingUser.name}"/>
													</hx:columnEx>
													<hx:columnEx id="currentRejectingUserNameColumn">
														<ram:resourceOutputLink styleClass="outputLink" uri="/oslc/users/#{currentRejectingUser.identifier}" value="#{pc_ReviewDetails.pageContext}/secure/userDetail.faces" id="rejectingUserLink">
															<f:param id="currentRejectingUserIdParam" name="uid" value="#{currentRejectingUser.identifier}" />
															<h:outputText id="currentRejectingUserName" styleClass="outputText" value="#{currentRejectingUser.name}"/>
														</ram:resourceOutputLink>
														<ram:externalProfile id="currentUserDetailExternal" value="#{currentRejectingUser.identifier}" />
													</hx:columnEx>
												</hx:dataTableEx>
											</div>
											
											<div style="float: left; margin-right: 60px;">
												<h:outputText style="font-weight: bold;" id="currentAwaitingUsersText" value="#{currentAssetHistory.awaitingUsersText}"></h:outputText>
												<hx:dataTableEx  id="currentAwaitingUsersTable" value="#{currentAssetHistory.awaitingUsers}" var="currentAwaitingUser" border="0" cellpadding="2">
													<hx:columnEx id="currentAwaitingUserIconColumn" width="15px" align="right">
														<h:graphicImage id="currentAwaitingUserImage" value="#{currentAwaitingUser.imageURL}" 
															width="15" height="15" alt="#{currentAwaitingUser.name}"/>
													</hx:columnEx>
													<hx:columnEx id="currentAwaitingUserNameColumn">
														 <hx:jspPanel id="currentAwaitingUserNamePanel">
															<h:outputLink styleClass="outputLink" value="#{pc_ReviewDetails.pageContext}/community/userGroup.faces" 
																id="cArrentawaitingUserGroupLink" rendered="#{currentAwaitingUser.userGroup}">
																<f:param id="currentAwaitingUserGroupIdParam" name="ugid" value="#{currentAwaitingUser.id}" />
																<f:param id="currentAwaitingUserGroupCommunityIdParam" name="gid" value="#{pc_AssetDetailBase.asset.group.id}" />
																<ram:infopop id="currentAwaitingUserGroupInfoPop" text="#{currentAwaitingUser.name}"
																	content="#{currentAwaitingUser.userGroupInfopopHtml}" hover="true" rendered="#{currentAwaitingUser.userGroup}" /> 
															</h:outputLink>
															<ram:resourceOutputLink styleClass="outputLink" uri="/oslc/users/#{currentAwaitingUser.id}" value="#{pc_ReviewDetails.pageContext}/secure/userDetail.faces" 
																id="currentAwaitingUserLink" rendered="#{!currentAwaitingUser.userGroup}">
																<f:param id="currentAwaitingUserIdParam" name="uid" value="#{currentAwaitingUser.id}" />
																<h:outputText id="currentAwaitingUserName" value="#{currentAwaitingUser.name}" rendered="#{!currentAwaitingUser.userGroup}" />
															</ram:resourceOutputLink>
															<ram:externalProfile id="currentUserDetailExternal" value="#{currentAwaitingUser.id}" />
														</hx:jspPanel>
													</hx:columnEx>
												</hx:dataTableEx>
											</div>
											
											<div style="float: left; margin-right: 10px;">
												<h:outputText style="font-weight: bold;" id="currentVisualPolicyResultsText" value="#{currentAssetHistory.policyResultsText}"></h:outputText>
												<hx:dataTableEx  id="currentVisualPolicyTable" value="#{currentAssetHistory.visualPolicyResult}" var="currentVisualPolicyResult" border="0" cellpadding="2">
													<hx:columnEx id="currentVisualPolicyResultIconColumn" width="15px" align="right">
														<h:graphicImage id="currentAwaitingUserImage" value="#{currentVisualPolicyResult.icon}" 
															width="15" height="15" alt="#{currentVisualPolicyResult.name}"/>
													</hx:columnEx>
													<hx:columnEx id="currentVisualPolicyResultNameColumn">
														<h:outputText id="currentAwitingUserName" value="#{currentVisualPolicyResult.name}"></h:outputText>
													</hx:columnEx>
												</hx:dataTableEx>
											</div>
											<div style="clear:both;"></div>
										</div>
										<hx:jspPanel id="conditionSummariesSection" rendered="#{empty pc_ReviewDetails.displayNoActionsAvailableMessage}">
											<div>
												<h:outputText style="font-weight: bold;" id="availableActionsSectionTitle" value="#{bundle.label_availableActions}"></h:outputText>
											</div>
											<div>
												<h:outputText styleClass="sectionInstructions" style="margin: 0 10px 0 0" id="availableActionsInlineHelp" value="#{bundle.lifecycle_conditions_summary}"></h:outputText>
											</div>
											<div dojoType="ram.ConditionSummaries"></div>
										</hx:jspPanel>
									</div>
								</hx:jspPanel>
							</div>
						</div>
					</hx:jspPanel>

					<hx:jspPanel id="assetHistoryCommentPanel" rendered="#{(pc_ReviewDetails.collaborator || pc_ReviewDetails.teamspaceAdmin) && currentAssetHistory.authorized}">
						<a name="comments"></a>
						<div class="lifecyclePostBox" style="margin-top: 20px;">
							<div>
								<h:outputText id="commentTitleText" style="margin: 0px 0px 1px 2px;" value="#{bundle.lifecycle_text_comment}"></h:outputText>
							</div>
							
							<div>
								<a name="commentInput"> 
								<h:inputTextarea id="commentTextArea" style="width: 99%" rows="6" value="#{pc_ReviewDetails.lifecycleReviewComment}"/>
								<h:outputLabel id="commentTextAreaLabel" for="commentTextArea">
			                    </h:outputLabel>
								</a>
							</div>
							<div style="float: right; margin-right: 7px;">
								
								<hx:commandExButton
									id="reviewCommentGroupApproveButton"
									styleClass="commandExButton"
									style="margin-top: 10px" type="submit"
									value="#{bundle.button_approve}"
									rendered="#{pc_ReviewDetails.activeReviewer && !pc_ReviewDetails.hasReviewed && pc_ReviewDetails.approveInMultipleGroups}"									
								>
								<hx:behavior id="approveButtonBehavior1" event="onclick" targetAction="selectGroupDialogForm1" behaviorAction="show;stop" />									 	
								</hx:commandExButton>
								<hx:commandExButton
									id="reviewCommentApproveButton"
									styleClass="commandExButton"
									style="margin-top: 10px" type="submit"
									value="#{bundle.button_approve}"
									rendered="#{pc_ReviewDetails.activeReviewer && !pc_ReviewDetails.hasReviewed && !pc_ReviewDetails.approveInMultipleGroups}"
									action="#{pc_ReviewDetails.doApproveAsset}"
								>										 	
								</hx:commandExButton>
								
								<hx:commandExButton
									id="reviewCommentGroupRejectButton"
									styleClass="commandExButton"
									style="margin-top: 10px" type="submit"
									value="#{bundle.button_reject}"
									rendered="#{pc_ReviewDetails.activeReviewer && !pc_ReviewDetails.hasReviewed && pc_ReviewDetails.approveInMultipleGroups}"								
								>
								<hx:behavior id="rejectButtonBehavior1" event="onclick" targetAction="rejectGroupDialogForm1" behaviorAction="show;stop" />
								</hx:commandExButton>								
								<hx:commandExButton
									id="reviewCommentRejectButton"
									styleClass="commandExButton"
									style="margin-top: 10px" type="submit"
									value="#{bundle.button_reject}"
									rendered="#{pc_ReviewDetails.activeReviewer && !pc_ReviewDetails.hasReviewed && !pc_ReviewDetails.approveInMultipleGroups}"
									action="#{pc_ReviewDetails.doRejectAsset}"									
								>								
								</hx:commandExButton>
								<hx:commandExButton id="reviewCommentButton" styleClass="commandExButton" style="display:none;margin-top: 10px" 
									type="button" value="#{bundle.button_post_comment}">
								</hx:commandExButton>
								<hx:commandExButton id="realReviewCommentButton" styleClass="commandExButton"
									type="submit" value="#{bundle.button_post_comment}" style="margin-top: 10px;" action="#{pc_ReviewDetails.doPostLifecycleReviewComment}">
									<hx:behavior id="realReviewCommentButtonBehavior" event="onclick" behaviorAction="hide;show" targetAction="realReviewCommentButton;reviewCommentButton" />
								</hx:commandExButton>
							</div>
							<div style="clear:both"></div>
						</div>
					</hx:jspPanel>

					<hx:dataTableEx id="currentReviewEventTable" value="#{currentAssetHistory.stateEvent}" var="currentReviewEvents" 
						styleClass="displayTable" border="0">
						<hx:columnEx id="iconColumn" width="66px" valign="top">
							<hx:jspPanel id="currentUserImagePanel">
								<h:graphicImage id="currentUserImage" value="#{currentReviewEvents.iconURL}" rendered="#{currentReviewEvents.iconURL != null}"
									width="50" height="50" alt="#{currentReviewEvents.author}"/>
								
								<%-- Need to check if we're on WAS or Tomcat because this is rendering differently due to different versions of JSF --%>
								<h:graphicImage id="currentOverlayImageWAS" value="#{currentReviewEvents.overlayURL}" rendered="#{currentReviewEvents.iconURL != null && currentReviewEvents.overlayURL != null && pc_ReviewDetails.websphere}"
									alt="#{currentReviewEvents.author}" style="position:relative; top: 0px; left: -13px;"/> 
								<h:graphicImage id="currentOverlayImageTomcat" value="#{currentReviewEvents.overlayURL}" rendered="#{currentReviewEvents.iconURL != null && currentReviewEvents.overlayURL != null && !pc_ReviewDetails.websphere}"
								alt="#{currentReviewEvents.author}" style="position:relative; top:-14px; left: 36px;"/>
								 
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="currentMessageColumn" valign="top">
							<h:panelGrid id="currentPanelGrid1" columns="1"  style="width: 100%; table-layout: fixed;">
								<h:panelGroup id="currentReviewEventsUserGroup">
								    <hx:jspPanel id="currentReviewEventsAuthorPanel" rendered="#{currentReviewEvents.author != null}">
								    	<ram:resourceRequestLink id="currentUserLink" styleClass="requestLink" action="userDetail" uri="/oslc/users/#{currentReviewEvents.uid}" rendered="#{currentReviewEvents.userEvent}">
											<h:outputText id="currentRserLinkText" styleClass="outputText" value="#{currentReviewEvents.author}"></h:outputText>
											<f:param id="currentUserLinkTextUID" name="uid" value="#{currentReviewEvents.uid}"></f:param>
										</ram:resourceRequestLink>
										<ram:externalProfile id="currentUserDetailExternal1" dynamic="true" value="#{currentReviewEvents.uid}" />
										<h:outputText id="currentGroupLinkText" styleClass="outputText" rendered="#{currentReviewEvents.gid != null}" 
											value=" - #{currentReviewEvents.group}"></h:outputText>
										<h:outputText id="currentNonUserAuthor" styleClass="outputText" value="#{currentReviewEvents.author}" escape="false" rendered="#{!currentReviewEvents.userEvent}" />

										<h:outputText id="currentVommentDate" value="#{currentReviewEvents.date}" style="margin-left: 2px;" styleClass="deemphasized">
											<f:convertDateTime type="both" dateStyle="medium" timeStyle="short" timeZone="#{pc_ReviewDetails.timezone}" locale="#{pc_ReviewDetails.locale}" />
										</h:outputText>
									</hx:jspPanel>
									<hx:jspPanel id="currentReviewEventsNoAuthorPanel" rendered="#{currentReviewEvents.author == null}">
										<h:outputText id="currentCommentDateNoAuthor" value="#{currentReviewEvents.date}" styleClass="deemphasized">
											<f:convertDateTime type="both" dateStyle="medium" timeStyle="short" timeZone="#{pc_ReviewDetails.timezone}" locale="#{pc_ReviewDetails.locale}" />
										</h:outputText>
									</hx:jspPanel>
								</h:panelGroup>
								<h:panelGroup id="currentReviewEventsMessageGroup"> 
									<hx:jspPanel id="currentVoteJSPPanel" rendered="#{!currentReviewEvents.voteWithdrawn}">
										<hx:jspPanel id="currentApprovedAssetPanel" rendered="#{currentReviewEvents.voteApprove}">
											<h:outputText id="currentApprovedAssetText" styleClass="approved"  value="#{bundle.lifecycle_vote_approved}"></h:outputText>
										</hx:jspPanel>
										<hx:jspPanel id="currentRejectedAssetPanel" rendered="#{currentReviewEvents.voteReject}">
											<h:outputText id="currentRejectedAssetText" styleClass="rejected"  value="#{bundle.lifecycle_vote_rejected}"></h:outputText>
										</hx:jspPanel>
									</hx:jspPanel>
									<hx:jspPanel id="currentVoteWidthdrawnJSPPanel" rendered="#{currentReviewEvents.voteWithdrawn}">
										<hx:jspPanel id="currentVoteWithdrawnApprovedPanel" rendered="#{currentReviewEvents.voteApprove}">
											<h:outputText id="currentWithdrawnApprovedAssetText" styleClass="approved" style="text-decoration: line-through;" 
												value="#{bundle.lifecycle_vote_approved}"></h:outputText>
										</hx:jspPanel>
										<hx:jspPanel id="currentVoteWithdrawnRejectedPanel" rendered="#{currentReviewEvents.voteReject}">
											<h:outputText id="currentWithdrawnRejectedAssetText" styleClass="rejected" style="text-decoration: line-through;"    
											value="#{bundle.lifecycle_vote_rejected}"></h:outputText>
										</hx:jspPanel>
									</hx:jspPanel>
									<h:graphicImage id="currentReviewEventOverlayImage" value="#{currentReviewEvents.overlayURL}" rendered="#{currentReviewEvents.displayOverlayIconInMessage && currentReviewEvents.overlayURL != null}"
											style="vertical-align: top; margin-right: 5px;"/>
									<h:outputText id="currentWithdrawnMessageText" escape="false" value="#{currentReviewEvents.message}"></h:outputText>
								</h:panelGroup>
							</h:panelGrid>
							<hx:jspPanel id="currentShowChildrenPanel" rendered="#{not empty currentReviewEvents.childEvents}">
								<div style="margin-top: 10px;">
									<a href="#" id="currentShowChildEvents" onclick="toggleChildEvents(this);return false" style="margin-top: 10px;">${bundle.lifecycle_show_previous_policy_results}</a>
									<a href="#" id="currentHideChildEvents" onclick="toggleChildEvents(this);return false" style="margin-top: 10px; display: none;">${bundle.lifecycle_hide_previous_policy_results}</a>
								</div>
							</hx:jspPanel> 
							<hx:dataTableEx id="currentChildReviewEventTable" rendered="#{not empty currentReviewEvents.childEvents}" value="#{currentReviewEvents.childEvents}" var="currentChildReviewEvents" 
								styleClass="displayTable" border="0" style="display: none;">
								<hx:columnEx id="currentChildMessageColumn" valign="top">
									<h:panelGroup id="currentChildEventsGroup" style="margin-left: 10px;">
										<h:graphicImage id="currentChildOverlayImage" value="#{currentChildReviewEvents.overlayURL}" rendered="#{currentReviewEvents.displayOverlayIconInMessage && currentChildReviewEvents.overlayURL != null}"
											style="vertical-align: top; margin-right: 5px;"/>
										<h:outputText id="currentChildMssageText" escape="false" value="#{currentChildReviewEvents.message}"></h:outputText>
										<h:outputText id="currentReviewEventChildDate" value="#{currentChildReviewEvents.date}" style="margin-left: 5px;" styleClass="deemphasized">
											<f:convertDateTime type="both" dateStyle="medium" timeStyle="short" timeZone="#{pc_ReviewDetails.timezone}" locale="#{pc_ReviewDetails.locale}" />
										</h:outputText>
									</h:panelGroup>
								</hx:columnEx>
							</hx:dataTableEx>
							
						</hx:columnEx>
					
					</hx:dataTableEx>

				</hx:dataIterator>
				
				<h:panelGroup id="showFullHistoryAjaxGroup" rendered="#{!pc_ReviewDetails.updateEditorBusyDialogVisible}">
					<hx:ajaxRefreshSubmit id="showFullHistoryAjax" onerror="alert('Error loading review history.');"/>
					<h:inputHidden id="showFullHistoryHiddenText" value="#{pc_ReviewDetails.shownFullHistory}"></h:inputHidden>
					<hx:dataIterator id="assetHistoryIterator" value="#{pc_ReviewDetails.assetHistory}" var="assetHistory" rendered="#{pc_ReviewDetails.shownFullHistory}">
					    <hx:jspPanel id="stateHeaderPanelPrivate" rendered="#{assetHistory.privateReview && !assetHistory.authorized}">
							<div class="assetCallOutBorder"></div>
							<div id="stateStatusBarPrivate" class="assetCallOut" style="height: 20px;">
								<div style="margin: 2px 0px 10px 6px;">
								
									<ram:infopop id="previousStateStatusBarHelpPrivate" styleClass="jazz-app-ua-TextHoverHelp assetCallOutFont" contextId="agdc0210" text="#{assetHistory.tableHeader}"/>
									<img style="margin-left: 5px" alt="${bundle.label_private_collaboration_state_not_authorized}" title="${bundle.label_private_collaboration_state_not_authorized}" 
											src="<%=request.getContextPath() + "/theme/images/icons/obj16/statusLocked.gif"%>" align="top"></img>
										
								</div>
							</div>
						</hx:jspPanel>
						<hx:jspPanel id="stateHeaderPanel" rendered="#{!assetHistory.privateReview || assetHistory.authorized}">
							<div class="assetCallOutBorder"></div>
							<div id="stateStatusBar" class="assetCallOut" style="height: 100%; min-height: 20px;">
								<div style="margin: 2px 0px 10px 6px;">
									<hx:jspPanel id="stateHistoryStatusLinkPanel">
										<span style="float: right;">
											<h:outputLink id="historyShowSummary" value="javascript: void(0);" onclick="javascript:showSummary(this, '#{assetHistory.id}');return false" style="padding-right: 5px;">
												<h:outputText id="historyShowSummaryText" value="#{bundle.lifecycle_show_status}"></h:outputText>
											</h:outputLink>
											<h:outputLink id="historyHideSummary" value="javascript: void(0);" onclick="javascript:hideSummary(this, '#{assetHistory.id}');return false" style="padding-right: 5px; display: none;">
												<h:outputText id="historyHideSummaryText" value="#{bundle.lifecycle_hide_status}"></h:outputText>
											</h:outputLink>
										</span>
									</hx:jspPanel>
									<hx:jspPanel  id="previousStateStatusBarHelpPanel" rendered="#{!assetHistory.privateReview}">
										<ram:infopop id="previousStateStatusBarHelp" styleClass="jazz-app-ua-TextHoverHelp assetCallOutFont" contextId="agdc0210" text="#{assetHistory.tableHeader}"/>
									</hx:jspPanel>
									<hx:jspPanel  id="privateCollaborationLockAuthorized" rendered="#{assetHistory.privateReview}">
										<ram:infopop id="previousStateStatusBarHelpPrivateAuthorized" styleClass="jazz-app-ua-TextHoverHelp assetCallOutFont" contextId="agdc0210" text="#{assetHistory.tableHeader}"/>
										<img style="margin-left: 5px" src="<%=request.getContextPath() + "/theme/images/icons/obj16/statusLocked.gif"%>"
											alt="${bundle.label_private_collaboration_state_authorized}" title="${bundle.label_private_collaboration_state_authorized}" align="top"></img>
									</hx:jspPanel>
									
									<h:outputText id="historyHtmlOpenDiv" value="#{assetHistory.htmlDivOpen}" escape="false"></h:outputText>
										<div style="background-color: #FFFFFF; border: 1px solid #DDDDDD; padding: 5px; margin: 0 10px 10px 0">
											<div style="float: left; margin-right: 60px;">
												<h:outputText style="font-weight: bold;" id="approvingUsersText" value="#{assetHistory.approvingUsersText}"></h:outputText>
												<hx:dataTableEx  id="approvingUsersTable" value="#{assetHistory.approvingUsers}" var="approveUser" border="0" cellpadding="2">
													<hx:columnEx id="approvingUserIconColumn" width="15px" align="right">
														<h:graphicImage id="approverImage" value="#{approveUser.imageURL}" 
															width="15" height="15" alt="#{approveUser.name}"/>
													</hx:columnEx>
													<hx:columnEx id="approvingUserNameColumn">
														<ram:resourceOutputLink styleClass="outputLink" uri="/oslc/users/#{approveUser.identifier}" value="#{pc_ReviewDetails.pageContext}/secure/userDetail.faces" id="approveUserLink">
															<f:param id="approveUserIdParam" name="uid" value="#{approveUser.identifier}" />
															<h:outputText id="approveUserName" styleClass="outputText" value="#{approveUser.name}"/>
														</ram:resourceOutputLink>
														<ram:externalProfile id="userDetailExternal" value="#{approveUser.identifier}" />
													</hx:columnEx>
												</hx:dataTableEx>
											</div>		
											
											<div style="float: left; margin-right: 60px;">
												<h:outputText style="font-weight: bold;"  id="rejectingUsersText" value="#{assetHistory.rejectingUsersText}"></h:outputText>
												<hx:dataTableEx  id="rejectingUsersTable" value="#{assetHistory.rejectingUsers}" var="rejectingUser" border="0" cellpadding="2">
													<hx:columnEx id="rejectingUserUconColumn" width="15px" align="right">
														<h:graphicImage id="rejectingUserImage" value="#{rejectingUser.imageURL}" 
															width="15" height="15" alt="#{rejectingUser.name}"/>
													</hx:columnEx>
													<hx:columnEx id="rejectingUserNameColumn">
														<ram:resourceOutputLink styleClass="outputLink" uri="/oslc/users/#{rejectingUser.identifier}" value="#{pc_ReviewDetails.pageContext}/secure/userDetail.faces" id="rejectingUserLink">
															<f:param id="rejectingUserIdParam" name="uid" value="#{rejectingUser.identifier}" />
															<h:outputText id="rejectingUserName" styleClass="outputText" value="#{rejectingUser.name}"/>
														</ram:resourceOutputLink>
														<ram:externalProfile id="userDetailExternal" value="#{rejectingUser.identifier}" />
													</hx:columnEx>
												</hx:dataTableEx>
											</div>
											
											<div style="float: left; margin-right: 60px;">
												<h:outputText style="font-weight: bold;" id="awaitingUsersText" value="#{assetHistory.awaitingUsersText}"></h:outputText>
												<hx:dataTableEx  id="awaitingUsersTable" value="#{assetHistory.awaitingUsers}" var="awaitingUser" border="0" cellpadding="2">
													<hx:columnEx id="awaitingUserIconColumn" width="15px" align="right">
														<h:graphicImage id="awaitingUserImage" value="#{awaitingUser.imageURL}" 
															width="15" height="15" alt="#{awaitingUser.name}"/>
													</hx:columnEx>
													<hx:columnEx id="awaitingUserNameColumn">
														 <hx:jspPanel id="awaitingUserNamePanel">
															<h:outputLink styleClass="outputLink" value="#{pc_ReviewDetails.pageContext}/community/userGroup.faces" 
																id="awaitingUserGroupLink" rendered="#{awaitingUser.userGroup}">
																<f:param id="awaitingUserGroupIdParam" name="ugid" value="#{awaitingUser.id}" />
																<f:param id="awaitingUserGroupCommunityIdParam" name="gid" value="#{pc_AssetDetailBase.asset.group.id}" />
																<ram:infopop id="awaitingUserGroupInfoPop" text="#{awaitingUser.name}"
																	content="#{awaitingUser.userGroupInfopopHtml}" hover="true" rendered="#{awaitingUser.userGroup}" /> 
															</h:outputLink>
															<ram:resourceOutputLink styleClass="outputLink" uri="/oslc/users/#{awaitingUser.id}" value="#{pc_ReviewDetails.pageContext}/secure/userDetail.faces" 
																id="awaitingUserLink" rendered="#{!awaitingUser.userGroup}">
																<f:param id="awaitingUserIdParam" name="uid" value="#{awaitingUser.id}" />
																<h:outputText id="awaitingUserName" value="#{awaitingUser.name}" rendered="#{!awaitingUser.userGroup}" />
															</ram:resourceOutputLink>
															<ram:externalProfile id="userDetailExternal" value="#{awaitingUser.id}" />
														</hx:jspPanel>
													</hx:columnEx>
												</hx:dataTableEx>
											</div>
											
											<div style="float: left; margin-right: 10px;">
												<h:outputText style="font-weight: bold;" id="visualPolicyResultsText" value="#{assetHistory.policyResultsText}"></h:outputText>
												<hx:dataTableEx  id="visualPolicyTable" value="#{assetHistory.visualPolicyResult}" var="visualPolicyResult" border="0" cellpadding="2">
													<hx:columnEx id="visualPolicyResultIconColumn" width="15px" align="right">
														<h:graphicImage id="awaitingUserImage" value="#{visualPolicyResult.icon}" 
															width="15" height="15" alt="#{visualPolicyResult.name}"/>
													</hx:columnEx>
													<hx:columnEx id="visualPolicyResultNameColumn">
														<h:outputText id="awitingUserName" value="#{visualPolicyResult.name}"></h:outputText>
													</hx:columnEx>
												</hx:dataTableEx>
											</div>
											<div style="clear:both;"></div>
										</div>
									<h:outputText id="historyHtmlCloseDiv" value="#{assetHistory.htmlDivClose}" escape="false"></h:outputText>
								</div>
							</div>
						</hx:jspPanel>

						<hx:dataTableEx id="reviewEventTable" value="#{assetHistory.stateEvent}" var="reviewEvents" 
							styleClass="displayTable" border="0">
							<hx:columnEx id="iconColumn" width="66px" valign="top">
								<hx:jspPanel id="userImagePanel">
									<h:graphicImage id="userImage" value="#{reviewEvents.iconURL}" rendered="#{reviewEvents.iconURL != null}"
										width="50" height="50" alt="#{reviewEvents.author}"/>
									
									<%-- Need to check if we're on WAS or Tomcat because this is rendering differently due to different versions of JSF --%>
									<h:graphicImage id="overlayImageWAS" value="#{reviewEvents.overlayURL}" rendered="#{reviewEvents.iconURL != null && reviewEvents.overlayURL != null && pc_ReviewDetails.websphere}"
										alt="#{reviewEvents.author}" style="position:relative; top: 0px; left: -13px;"/> 
									<h:graphicImage id="overlayImageTomcat" value="#{reviewEvents.overlayURL}" rendered="#{reviewEvents.iconURL != null && reviewEvents.overlayURL != null && !pc_ReviewDetails.websphere}"
									alt="#{reviewEvents.author}" style="position:relative; top:-14px; left: 36px;"/>
									 
								</hx:jspPanel>
							</hx:columnEx>
							<hx:columnEx id="messageColumn" valign="top">
								<h:panelGrid id="panelGrid1" columns="1"  style="width: 100%; table-layout: fixed;">
									<h:panelGroup id="reviewEventsUserGroup">
									    <hx:jspPanel id="reviewEventsAuthorPanel" rendered="#{reviewEvents.author != null}">
									    	<ram:resourceRequestLink id="userLink" styleClass="requestLink" action="userDetail" uri="/oslc/users/#{reviewEvents.uid}" rendered="#{reviewEvents.userEvent}">
												<h:outputText id="userLinkText" styleClass="outputText" value="#{reviewEvents.author}"></h:outputText>
												<f:param id="userLinkTextUID" name="uid" value="#{reviewEvents.uid}"></f:param>
											</ram:resourceRequestLink>
											<ram:externalProfile id="userDetailExternal1" dynamic="true" value="#{reviewEvents.uid}" />
											<h:outputText id="groupLinkText" styleClass="outputText" rendered="#{reviewEvents.gid != null}" 
												value=" - #{reviewEvents.group}"></h:outputText>
											<h:outputText id="nonUserAuthor" styleClass="outputText" value="#{reviewEvents.author}" escape="false" rendered="#{!reviewEvents.userEvent}" />
	
											<h:outputText id="commentDate" value="#{reviewEvents.date}" style="margin-left: 2px;" styleClass="deemphasized">
												<f:convertDateTime type="both" dateStyle="medium" timeStyle="short" timeZone="#{pc_ReviewDetails.timezone}" locale="#{pc_ReviewDetails.locale}" />
											</h:outputText>
										</hx:jspPanel>
										<hx:jspPanel id="reviewEventsNoAuthorPanel" rendered="#{reviewEvents.author == null}">
											<h:outputText id="commentDateNoAuthor" value="#{reviewEvents.date}" styleClass="deemphasized">
												<f:convertDateTime type="both" dateStyle="medium" timeStyle="short" timeZone="#{pc_ReviewDetails.timezone}" locale="#{pc_ReviewDetails.locale}" />
											</h:outputText>
										</hx:jspPanel>
									</h:panelGroup>
									<h:panelGroup id="reviewEventsMessageGroup"> 
										<hx:jspPanel id="voteJSPPanel" rendered="#{!reviewEvents.voteWithdrawn}">
											<hx:jspPanel id="approvedAssetPanel" rendered="#{reviewEvents.voteApprove}">
												<h:outputText id="approvedAssetText" styleClass="approved"  value="#{bundle.lifecycle_vote_approved}"></h:outputText>
											</hx:jspPanel>
											<hx:jspPanel id="rejectedAssetPanel" rendered="#{reviewEvents.voteReject}">
												<h:outputText id="rejectedAssetText" styleClass="rejected"  value="#{bundle.lifecycle_vote_rejected}"></h:outputText>
											</hx:jspPanel>
										</hx:jspPanel>
										<hx:jspPanel id="voteWidthdrawnJSPPanel" rendered="#{reviewEvents.voteWithdrawn}">
											<hx:jspPanel id="voteWithdrawnApprovedPanel" rendered="#{reviewEvents.voteApprove}">
												<h:outputText id="withdrawnApprovedAssetText" styleClass="approved" style="text-decoration: line-through;" 
													value="#{bundle.lifecycle_vote_approved}"></h:outputText>
											</hx:jspPanel>
											<hx:jspPanel id="voteWithdrawnRejectedPanel" rendered="#{reviewEvents.voteReject}">
												<h:outputText id="withdrawnRejectedAssetText" styleClass="rejected" style="text-decoration: line-through;"    
												value="#{bundle.lifecycle_vote_rejected}"></h:outputText>
											</hx:jspPanel>
										</hx:jspPanel>
										<h:graphicImage id="reviewEventOverlayImage" value="#{reviewEvents.overlayURL}" rendered="#{reviewEvents.displayOverlayIconInMessage && reviewEvents.overlayURL != null}"
												style="vertical-align: top; margin-right: 5px;"/>
										<h:outputText id="withdrawnMessageText" escape="false" value="#{reviewEvents.message}"></h:outputText>
									</h:panelGroup>
								</h:panelGrid>
								<hx:jspPanel id="showChildrenPanel" rendered="#{not empty reviewEvents.childEvents}">
									<div style="margin-top: 10px;">
										<a href="#" id="showChildEvents" onclick="toggleChildEvents(this);return false" style="margin-top: 10px;">${bundle.lifecycle_show_previous_policy_results}</a>
										<a href="#" id="hideChildEvents" onclick="toggleChildEvents(this);return false" style="margin-top: 10px; display: none;">${bundle.lifecycle_hide_previous_policy_results}</a>
									</div>
								</hx:jspPanel> 
								<hx:dataTableEx id="childReviewEventTable" rendered="#{not empty reviewEvents.childEvents}" value="#{reviewEvents.childEvents}" var="childReviewEvents" 
									styleClass="displayTable" border="0" style="display: none;">
									<hx:columnEx id="childMessageColumn" valign="top">
										<h:panelGroup id="childEventsGroup" style="margin-left: 10px;">
											<h:graphicImage id="childOverlayImage" value="#{childReviewEvents.overlayURL}" rendered="#{reviewEvents.displayOverlayIconInMessage && childReviewEvents.overlayURL != null}"
												style="vertical-align: top; margin-right: 5px;"/>
											<h:outputText id="childMssageText" escape="false" value="#{childReviewEvents.message}"></h:outputText>
											<h:outputText id="reviewEventChildDate" value="#{childReviewEvents.date}" style="margin-left: 5px;" styleClass="deemphasized">
												<f:convertDateTime type="both" dateStyle="medium" timeStyle="short" timeZone="#{pc_ReviewDetails.timezone}" locale="#{pc_ReviewDetails.locale}" />
											</h:outputText>
										</h:panelGroup>
									</hx:columnEx>
								</hx:dataTableEx>
								
							</hx:columnEx>
						
						</hx:dataTableEx>

					</hx:dataIterator>
					
					<hx:jspPanel id="retrievingHistoryPanel">
						<div id="retrievingHistorySection" style="display: none; margin-top: 10px;">
							<h:graphicImage id="retrievingHistoryAnimatedBusyIcon" value="/theme/images/icon_animated_busy.gif"
								style="vertical-align: middle;" alt="#{bundle.alt_loading_icon}" />
							<h:outputText id="retrievingHistoryText" style="margin-left: 5px;" value="#{bundle.lifecycle_message_retriving_state_history}"></h:outputText>
						</div> 
					</hx:jspPanel>
					
				</h:panelGroup>

				<div style="margin-top: 10px;float:right;text-align:right;">
					<hx:requestLink id="showLegacyHistoryLink" action="assetReview" rendered="#{pc_ReviewDetails.legacyReviewHistoryAvailable}" 
						styleClass="outputLink" style="margin-top: 10px;">
						<h:outputText id="showLegacyHistoryText" value="#{bundle.lifecycle_link_view_legacy_history}" />
						<f:param id="guidParamLegacyHistory" name="guid" value="#{pc_ReviewDetails.asset.id}"></f:param>
						<f:param id="versionParamLegacyHistory" name="v" value="#{pc_ReviewDetails.asset.version}"></f:param>
						<f:param id="submissionParamPLegacyHistory" name="submission" value="#{pc_ReviewDetails.asset.submissionAsset}"></f:param>
					</hx:requestLink>
				</div>

				<div style="margin-top: 10px;">
					<h:outputLink id="showFullHistoryLink" value="#" styleClass="moreLink" 
					 	style="margin-top: 10px;">
						<h:outputText id="showFullHistoryText" value="#{bundle.lifecycle_link_view_history}" />
						<hx:behavior event="onload" id="showFullHistoryBehavior" onActionFunction="setShowFullHistory()" 
							targetAction="showFullHistoryAjaxGroup" behaviorAction="get;stop"></hx:behavior>
					</h:outputLink>
				</div>

				<script type="text/javascript">
					function setShowFullHistory() {
						document.getElementById('mainForm:showFullHistoryHiddenText').value = 'true'; 
						document.getElementById('mainForm:showFullHistoryLink').style.display = 'none';
						document.getElementById('retrievingHistorySection').style.display = 'block';
					}
				</script>
			</div>
			

			<h:inputHidden id="userId" value="#{pc_ReviewDetails.RAMUser.uid}" />
			<h:inputHidden id="currentState" value="#{pc_ReviewDetails.stateConfiguration.state.value.identifier}" />
			<ram:context id="lifecycleReviewGuid" name="guid" />
			<ram:context id="lifecycleReviewV" name="v" defaultValue="#{pc_ReviewDetails.asset.version}" />
			<ram:context id="lifecycleReviewSubmission" name="submission" defaultValue="#{pc_ReviewDetails.asset.submissionAsset}" />
		</ram:form>
		</div>
		</div>
								
		<%@ include file="/theme/footer.jspf" %>
	</hx:scriptCollector>
	</body>
</f:view>
</html>