<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/Home.java" --%><%-- /jsf:pagecode --%>
<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2006. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  -----------------------------------------------------------------------------%>

<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%> 
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>
 
<html lang="${pageContext.response.locale}">
<head>
	<%@include file="theme/metaHeader.jspf"%>
	<%@include file="theme/cssHideRightColumn.jspf"%>
	<link rel="csh" href="${applicationScope.cshPath}">
	<fmt:setBundle basename="com/ibm/ram/repository/web/bundles/webMessages" />
	<fmt:setBundle basename="com/ibm/ram/repository/web/bundles/customMessages" />
	<f:loadBundle basename="com/ibm/ram/repository/web/bundles/customMessages" var="homeBundle" />
	<title>${bundle.homeTitle}</title>	
	<style type="text/css">
		h1 { display:block }
	</style>

	<script type="text/javascript">
	function onLoadHandler() {
		if (document.getElementById('username')) {
			document.getElementById('username').focus();
		}
	}
	</script>
</head>
<f:view>
	<body class="ram" onload="onLoadHandler()">
	<hx:scriptCollector id="scriptCollector1">
	
		<%@ include file="/theme/header.jspf" %>
		
		<div class="dashboard-page">
		<div id="contentColumn">
		<div class="inside">
			<div class="dashboard-content">


				<ram:form id="submitEditorBusyDialogForm">
					<hx:panelDialog type="modal" align="center" valign="middle" 
						id="submitEditorBusyDialog" styleClass="panelDialog" style="width: 600px;"
						title="#{bundle.submit_wiz_submit_header_wait_text}" initiallyShow="#{pc_Home.submitEditorBusyDialogVisible}">
							<div id="submitEditorBusyErrorMessage" class="warningBlock" style="margin-left: 15px">
								<div class="body">
									<div class="message">
										<h:outputText id="submitEditorBusyText" value="#{bundle.SubmitAssetHandler_submitEditorBusy}" escape="false"></h:outputText>
									</div>
								</div>
							</div>
						<h:panelGroup id="submitEditorBusyDialogGroup" style="width: 600px;">
							<h:panelGroup id="submitEditorBusyGroup" styleClass="dialogActionGroup">
								<hx:commandExButton id="submitWizYes" styleClass="commandExButton"
									iconDepressed="/theme/images/transparent.gif"
									type="submit"
									value="#{bundle.button_continue}" action="#{pc_Home.doSubmitActionForce}">
								</hx:commandExButton>
								<hx:commandExButton id="submitWizNo" styleClass="commandExButton"
									iconDepressed="/theme/images/transparent.gif"
									type="submit"
									action="#{pc_Home.doCancelSubmitEditorBusyAction}"
									value="#{bundle.button_cancel}">
								</hx:commandExButton>
							</h:panelGroup>
						</h:panelGroup>
					</hx:panelDialog>
				</ram:form>

				<div id="column1-span" class="three-col-span">
					<%@include file="theme/custom/homeContent.jspf"%>
				</div>
				<div id="column3" class="three-col">
					
					<%@include file="/includes/loginForm.jspf"%>

					<ram:panelSectionEx id="myAssetsSection" styleClass="ram-section green" initClosed="false"
						rendered="#{not loginUser.user.anonymous and not empty pc_Home.myAssets.assetList}">
						<f:facet name="opened">
							<h:panelGroup id="myAssets">
								<h:outputText id="myAssetsTitle" value="#{pc_Home.myAssetsViewletTitle}" escape="false" />
							</h:panelGroup>		
						</f:facet>
						<hx:dataTableEx id="myAssetsTable" value="#{pc_Home.myAssets.assetList}" var="assets"
							rows="10" border="0" width="100%" styleClass="listTable fixed" columnClasses="noClass,noClass,actionColumn">
							<hx:columnEx id="myAssetsName" style="white-space: nowrap;">
								<ram:resourceRequestLink id="myAssetLink" action="assetDetails" title="#{assets.name} #{bundle.common_ltr_mark}[#{assets.version}]" 
									value="#{assets.name} #{bundle.common_ltr_mark}[#{assets.version}]" uri="#{assets.resourceURI}">
									<f:param id="guidParam3" name="guid" value="#{assets.id}"></f:param>
									<f:param id="vParam3" name="v" value="#{assets.version}"></f:param>
									<f:param id="sParam3" name="submission" value="#{assets.submissionAsset}"></f:param>
								</ram:resourceRequestLink>
							</hx:columnEx>
						</hx:dataTableEx>
					</ram:panelSectionEx>
					
					<ram:panelSectionEx id="popularAssetsSection" styleClass="ram-section" initClosed="false"
						rendered="#{not empty pc_Home.popularAssets}">
						<f:facet name="opened">
							<h:panelGroup id="popularAssetsGroup">
								<h:outputText id="popularAssetsTitle" value="#{bundle.section_popular_assets}" />
							</h:panelGroup>		
						</f:facet>
						<hx:dataTableEx value="#{pc_Home.popularAssets}" var="assets" 
							id="popularAssetsTable" rows="10" 
							width="100%" styleClass="listTable fixed" columnClasses="noClass,noClass,actionColumn"
							border="0">
							<hx:columnEx id="popularAssetsTableName" style="white-space: nowrap">
								<ram:resourceRequestLink id="popularAssetsTableDetailsLink" action="assetDetails" title="#{assets.name} #{bundle.common_ltr_mark}[#{assets.identification.version}]" 
									value="#{assets.name} #{bundle.common_ltr_mark}[#{assets.identification.version}]" uri="#{assets.resourceURI}">
									<f:param id="guidParam1" name="guid" value="#{assets.identification.GUID}"></f:param>
									<f:param id="vParam1" name="v" value="#{assets.identification.version}"></f:param>
									<f:param id="sParam1" name="submission" value="#{assets.identification.pendingAsset}"></f:param>
								</ram:resourceRequestLink>
							</hx:columnEx>
							<hx:columnEx id="changeColumn" align="right" valign="top" style="white-space: nowrap;  width: 25px">
								<h:graphicImage id="popUpImg"  alt="#{bundle.alt_popularity_incresed}" rendered="#{assets.popularityScoreChange > 0}" value="/theme/images/icons/obj16/popularity-increased.gif" style="vertical-align: middle; margin-bottom: 2px;"/>
								<h:graphicImage id="popDownImg"  alt="#{bundle.alt_popularity_lowered}" rendered="#{assets.popularityScoreChange < 0}" value="/theme/images/icons/obj16/popularity-lowered.gif" style="vertical-align: middle; margin-bottom: 2px;"/>
							</hx:columnEx>
						</hx:dataTableEx>
					</ram:panelSectionEx>
					<ram:infopop id="popularAssetsHelp" contextId="link0001" styleClass="viewletInfopop" for="popularAssetsSection" placement="end" />
					
					
					<ram:panelSectionEx id="recentSubmitSection" styleClass="ram-section" initClosed="false" rendered="#{not empty pc_Home.recentUpdates}">
						<f:facet name="opened">
							<h:panelGroup id="recentSubmit">
								<h:outputText id="recentSubmitTitle" value="#{bundle.section_submissions_updates}" />
							</h:panelGroup>		
						</f:facet>
						<hx:dataTableEx id="recentSubmitTable" value="#{pc_Home.recentUpdates}" var="assets"
							rows="10" border="0" width="100%" styleClass="listTable fixed" columnClasses="noClass,noClass,actionColumn">
							<hx:columnEx id="name2" style="white-space: nowrap;">
								<ram:resourceRequestLink id="assetLink1" action="assetDetails" title="#{assets.name} #{bundle.common_ltr_mark}[#{assets.identification.version}]" 
								value="#{assets.name} #{bundle.common_ltr_mark}[#{assets.identification.version}]" uri="#{assets.resourceURI}">
									<f:param id="guidParam2" name="guid" value="#{assets.identification.GUID}"></f:param>
									<f:param id="vParam2" name="v" value="#{assets.identification.version}"></f:param>
									<f:param id="sParam2" name="submission" value="#{assets.identification.pendingAsset}"></f:param>
								</ram:resourceRequestLink>
							</hx:columnEx>
						</hx:dataTableEx>
					</ram:panelSectionEx>
					<ram:infopop id="recentSubmitHelp" contextId="link0005" styleClass="viewletInfopop" for="recentSubmitSection" placement="end" />
					
				</div>
			</div>
			
		</div>
		</div>
		</div>
		
		<%@include file="/theme/footer.jspf"%>
	</hx:scriptCollector>
	</body>
</f:view>
</html>
