dojo.provide('ram.RamDialog');

dojo.require('dijit.Dialog');
dojo.require('dojo.DeferredList');

dojo.declare(
	'ram.RamDialog',
	[dijit._Widget, dijit._Templated, dijit.Dialog],
	{
		templateString: dojo.cache('ram', 'templates/Dialog.html'),
		
		helpId: null, // the context ID for the dialog infopop
		visible: false,
		
		constructor: function(/*Map*/ args) {
			if (args['helpId'])
				this.helpId = args['helpId'];
		},
		
		postCreate: function() {
			this.inherited(arguments);
			if (this.helpId) {
				var span = document.createElement('span');
				span.id = this.id + '_infopop';
				span.className = 'dialogInfopop';
				var img = document.createElement('img');
				img.id = span.id + '_image';
				img.className = 'dialogInfopop';
				img.src = absoluteBaseUrl + '/theme/images/icons/obj16/info_indicator.gif';
				span.appendChild(img);
				this.containerNode.parentNode.appendChild(span);
				createPopup(span.id, this.helpId, null, true); // infopop.js must be loaded
			}
		},
		
		onOpen: function() {
		},
		
		show: function(skipImageFetch) {
			if (skipImageFetch == true) {
				this.inherited(arguments);
				setTimeout(dojo.hitch(this, function() {
					this.visible = true; // dijit.Dialog sets open to true before the fadeIn animation is complete
					if (this.onOpen)
						this.onOpen();
				}), this.duration);
			} else {
				// fetch the header images before showing the dialog - see defect https://jazz.net/jazz02/resource/itemName/com.ibm.team.workitem.WorkItem/61181
				var fetchImages = new dojo.DeferredList([
              		dojo.xhrGet({url: absoluteBaseUrl + '/theme/custom/images/dialogs/dialog_hdr_default.gif'}),
              		dojo.xhrGet({url: absoluteBaseUrl + '/theme/custom/images/dialogs/dialog_right.gif'}),
              		dojo.xhrGet({url: absoluteBaseUrl + '/theme/custom/images/dialogs/dialog_close.gif'}),
              		dojo.xhrGet({url: absoluteBaseUrl + '/theme/custom/images/dialogs/dialog_hdr_shadow.gif'})
          		]);
          		fetchImages.then(dojo.hitch(this, function() {
          			this.show(true);
          		}));
			}
		},
		
		hide: function() {
			if (this.visible) {
				this.inherited(arguments);
				this.visible = false;
			} else {
				// if visible == false, the dialog may be in the middle of the open animation, so wait until it is finished before attempting to hide.
				setTimeout(dojo.hitch(this, this.hide, this.duration));
			}
		}
		
	}
);