dojo.provide('ram.ui.Icon');
dojo.require('dijit._Templated');
dojo.require('dijit._Widget');
dojo.require('dojo.fx');

dojo.declare(
	'ram.ui.Icon',
	[dijit._Widget, dijit._Templated],
{
	templateString: null,
	templatePath: dojo.moduleUrl('ram.ui', 'templates/Icon.html'),
	
	imagePath: '',
	title: '',
	altText: '',
	actions: [],
	isIconHovered: false,
	isActionTableHovered: false,
	
	postCreate: function() {
		this.imagePath = getAbsoluteUrl(this.imagePath);
		this.image.src = this.imagePath;
		if (this.actions.length > 3)
			this.actions.slice(0, 2);
		for (var i = 0; i < this.actions.length; i++) {
			var container = this['action' + (i+1)];
			dojo.place(this.actions[i].domNode, container);
		}
	},
	
	addAction: function(action) {
		if (this.actions.length < 3) {
			this.actions.push(action);
			var container = this['action' + this.actions.length];
			dojo.place(action.domNode, container);
		}
	},
	
	_hoverIcon: function(event) {
		this.isIconHovered = true;
		this._fadeInActions();
	},
	
	_unhoverIcon: function(event) {
		this.isIconHovered = false;
		setTimeout(dojo.hitch(this, function() {
			if (this.isIconHovered == false && this.isActionTableHovered == false) {
				this._fadeOutActions();
			}
		}), 100);
	},
	
	onClick: function(event) {
		
	},
	
	_hoverActions: function() {
		this.isActionTableHovered = true;
	},
	
	_unhoverActions: function() {
		this.isActionTableHovered = false;
		setTimeout(dojo.hitch(this, function() {
			if (this.isActionTableHovered == false && this.isIconHovered == false) {
				this._fadeOutActions();
			}
		}), 100);
	},
	
	_fadeOutActions: function() {
		var anim = dojo.fadeOut({
			node: this.actionTable,
			onEnd: dojo.hitch(this, function() {
				dojo.style(this.actionTable, 'visibility', 'hidden');
			}),
			onAnimate: dojo.hitch(this, function() {
				if (this.isActionTableHovered == true || this.isIconHovered == true) {
					anim.stop();
					this._fadeInActions();
				}
			})
		});
		anim.play();
	},
	
	_fadeInActions: function() {
		dojo.fadeIn({
			node: this.actionTable,
			onBegin: dojo.hitch(this, function() {
				dojo.style(this.actionTable, 'visibility', '');
			})
		}).play();
	}
	
});
