dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("ram.categorytree.CategoryTree");
dojo.require("dijit.form.Button");
dojo.require("jazz.ui.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.TitlePane");
dojo.require("jazz.ui.StyledBox");
dojo.require("dojo.NodeList-traverse");

var CATEGORY_SCHEMA_URL = "categoryschema";
var ASSET_URL = "internal/assets";
var IMG_CATEGORY_SCHEMA = "/theme/images/icons/obj16/category_schema.gif";
var IMAGE_EXPAND = "/theme/images/icons/elcl16/expand-tree.gif";
var IMAGE_COLLAPSE = "/theme/images/icons/elcl16/collapse-tree.gif";

var IMG_RADIO_SELECTED = getAbsoluteUrl("theme/images/icons/elcl16/radio-full-select.gif");
var IMG_RADIO_UNSELECTED = getAbsoluteUrl("theme/images/icons/elcl16/radio-none-select.gif");
var IMG_RADIO_CHILD_SELECTED = getAbsoluteUrl("theme/images/icons/elcl16/radio-part-select.gif");
var IMG_CHECKBOX_SELECTED = getAbsoluteUrl("theme/images/icons/elcl16/check-full-select.gif");
var IMG_CHECKBOX_UNSELECTED = getAbsoluteUrl("theme/images/icons/elcl16/check-none-select.gif");
var IMG_CHECKBOX_CHILD_SELECTED = getAbsoluteUrl("theme/images/icons/elcl16/check-part-select.gif");

var IMG_ERROR = getAbsoluteUrl("theme/images/icons/obj16/error.gif");
var IMG_INFO =  getAbsoluteUrl("theme/images/icons/obj16/info_obj.gif");

var IMG_RADIO_SELECTED_ALT = "selected radio";
var IMG_RADIO_UNSELECTED_ALT = "unselected radio";
var IMG_RADIO_CHILD_SELECTED_ALT = "A child of this radio is selected";
var IMG_CHECKBOX_SELECTED_ALT = "selected checkbox";
var IMG_CHECKBOX_UNSELECTED_ALT = "unselected checkbox";
var IMG_CHECKBOX_CHILD_SELECTED_ALT = "A child of this checkbox is selected";

var HIDDEN_INPUT_ID = "form1:selectedCategories";
var PREVIEW_CONTAINER_ID = "categoryOutputContainer";

var PREVIEW_TREE_STYLE = "output_categorizeSchemaList";

var tooltip = null;



var TEST_LABEL_ASSET_TYPE = "role_test_asset_type"; 
var TEST_LABEL_ASSET_CLASSIFICATION = "role_test_asset_category"; 

function switchView(val){
	if(val == TEST_LABEL_ASSET_CLASSIFICATION){
		dojo.byId("form1:selectedCategories").setAttribute("value", "");
		getCategorySchemas('categoryInputContainer');
		dojo.style("submit-type", "display", "none");
		dojo.style("submit-categories", "display", "block");
		
	} else{
		dojo.style("submit-categories", "display", "none");
		dojo.style("submit-type", "display", "block");	
	}
	
}

/***************************************************
 *	Creates the popup for asset types and communities
 ************Read if using this function************
 *	The title and description will be encoded in the
 *	function. Do not pass in strings that are already 
 *	encoded or else double encoding will occur.
 ***************************************************/
function setToolTip(nodeId, description, title) {
	var hover = dijit.byId('DescriptionHoverPopup');
	if (hover)
		hover.destroy();
	if (description != null && description != '') {
		var tooltipMessage = new StringBuffer();
		if (title != '' && title != null) {
			tooltipMessage.append('<h1>');
			tooltipMessage.append(encodeHtml(title));
			tooltipMessage.append('</h1>');
			tooltipMessage.append('<div class="dividerWrapper"><div class="divider" dojoattachpoint="divider"></div></div>');
		}
		tooltipMessage.append('<span>');
		tooltipMessage.append(encodeHtml(description));
		tooltipMessage.append('</span>');
		hover = new jazz.ui.HoverPopup({
			id: 'DescriptionHoverPopup',
			around: nodeId,
			html: tooltipMessage.toString()
		});
		hover.maxWidth = 400;
		return hover;
	}
	return null;
}

/***************************************************
 *	Padding is required when a SELECT element has
 *	enough OPTION childred to cause a scroll bar to
 *	appear. If no padding is applied the popup will
 *	be displayed behind the scroll bar. Tried
 *	changing the z-index with ro result.
 ***************************************************/
function padToolTip(target){
	if(target.nodeName =='OPTION' && target.parentNode.scrollHeight > target.parentNode.clientHeight){
		var style = dojo.byId('jazz_ui_internal__MasterPopup_0').getAttribute('style');
		style += 'padding-left:20px;';
		dojo.byId('jazz_ui_internal__MasterPopup_0').setAttribute('style',style);
	}
}


/***************************************************
 *	The padding needs to be removed when 
 * 	the popup is closed because it will persist
 *	to other elements that do not require the 
 *	padding.
 ***************************************************/
function removePadding(){
	var patt=new RegExp('padding-left:.*;','');
	var style = dojo.byId('jazz_ui_internal__MasterPopup_0').getAttribute('style');
	style = style.replace(patt, '');
	dojo.byId('jazz_ui_internal__MasterPopup_0').setAttribute('style',style);
	tooltip.close();
}

/***************************************************
 *	Shows the description for 
 *	an asset type when it is hovered over.
 ***************************************************/
function showAssetTypeDescription(event) {
	var target;
	if (event.target)
		target = event.target;
	else if (event.srcElement)
		target = event.srcElement;
	var description = typeMap[target.value];
	tooltip = setToolTip('form1:assetTypes', description, null); 
	if (tooltip != null) {
			tooltip.open(target);
			padToolTip(target);
	}
}

/***************************************************
 *	Hides the description of an 
 *	asset type when the mouse leaves the element.
 ***************************************************/
function hideAssetTypeDescription() {
	if(tooltip != null)
		removePadding();
}

/***************************************************
 *	Shows the description for 
 *	a community when it is hovered over.
 ***************************************************/
function showCommunityDescription(event) {
	var target;
	if (event.target)
		target = event.target;
	else if (event.srcElement) // IE
		target = event.srcElement;
	var description = communityMap[target.value];
	tooltip = setToolTip('form1:groupname', description, null); 
	if (tooltip != null) {
		tooltip.open(target);
		padToolTip(target);
	}
}

/***************************
 *	Hides the description of a 
 *	community when the mouse leaves the element.
 **************************/
function hideCommunityDescription() {
	if(tooltip != null)
		removePadding();
}

function getCommunityId() {
	var groupInput = dojo.byId('form1:groupname'); // submit wizard
	if (groupInput) 
		return groupInput.value;
}


/***********************
 * Functions for categorization
 ***********************/

function getCategorySchemas(resultId) {	
	dojo.xhrGet({
		url: getAbsoluteUrl(CATEGORY_SCHEMA_URL),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		content: {gid: unescape(getUrlParameter("gid"))},
		// The LOAD function will be called on a successful response.
		load: function(response, ioArgs) {
			var schemas = response;
			//var tree = "";
			var expand = getAbsoluteUrl(IMAGE_EXPAND);
			var collapse = getAbsoluteUrl(IMAGE_COLLAPSE);
			var schemaImg = getAbsoluteUrl("theme/images/icons/obj16/category_schema.gif");
			
			// Clear the loading
			dojo.byId(resultId).innerHTML = "";
			
			for (var i=0; i<schemas.length; i++) {
				var levelId = schemas[i].name + i;
				var tree = new ram.categorytree.CategoryTree({levelId:levelId, description:schemas[i].description, name:schemas[i].name, expandImageUrl: expand, collapseImageUrl: collapse, schemaImageUrl: schemaImg});
				tree.setSchema(schemas[i]);
				dojo.byId(resultId).appendChild(tree.domNode); 
				
				tree.startup();

				
				dojo.connect(tree, "_getCategories", connectCategorySchema);
			}
			
			CategorizeTree_attachListener('form1');
			
			return response;
		},
		
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}

function connectCategorySchema(evt) {
	var uris = dojo.byId("form1:selectedCategories").value.split(";");
	for (var i=0; i<uris.length; i++) {
		if (uris[i].substring(0, uris[i].indexOf('#'))==this.uri && dojo.byId(uris[i]+"_image")) {
			// Only work on nodes for the schema that was expanded
			selectSchemaNode(dojo.byId(uris[i]+"_image"));
		}
	}
}

function selectSchemaNode(element) {
	switch (CategorizeTree_getValue(element)) {
		case RADIO_UNSELECTED:
			CategorizeTree_switchTo(element, RADIO_SELECTED, IMG_RADIO_SELECTED, IMG_RADIO_SELECTED_ALT);
			CategorizeTree_deselectSiblingsAndNephews(element);
			CategorizeTree_selectParents(element);
			return true;
		case CHECKBOX_UNSELECTED:
			CategorizeTree_switchTo(element, CHECKBOX_SELECTED, IMG_CHECKBOX_SELECTED, IMG_CHECKBOX_SELECTED_ALT);
			CategorizeTree_selectParents(element);
			return true;
	}
}



