dojo.require("dijit.dijit");   
dojo.require("ram.packageview.PackageView");
dojoConfig = {parseOnLoad: true};


function toggleTagClouds() {
	var lessTags = document.getElementById('tagDiv');
	var moreTags = document.getElementById('resultsForm:moreTagsDiv');
	
	if( moreTags.className == "moreTagsHidden" ) {
		moreTags.className = "moreTagsShow";
		lessTags.className = "tagsHidden";
	} else {
		moreTags.className = "moreTagsHidden";
		lessTags.className = "tagsShow";
	}
}


function toggleSearchOptions() {
	var advanced = document.getElementById('searchOptions');
	var normal = document.getElementById('normalSearch');
	if( advanced.style.display == "none" ) {
		advanced.style.display = "block";
		normal.style.display = "none";
	} else {
		advanced.style.display = "none";
		normal.style.display = "block";
	}
}

function setHiddenFields(id, version) {
	document.getElementById('resultsForm:aid').value = id;
	document.getElementById('resultsForm:aver').value = version;
}

function setFieldValue(id, value){
    
	if (document.getElementById(id).value == value){
		return false;
	}
	document.getElementById(id).value = value;
	return true;
}



function doError(thisObj, error) {
	alert("Error: " + error);
}

function setInputField(field1, field2){
	document.getElementById(field1).value = document.getElementById(field2).value;
}

function clearInputFields(field1, field2){
	document.getElementById(field1).value = "";
	document.getElementById(field2).value = "";
}

function setCalendarFields() {
	setInputField('advSearchForm:fromCalField', 'calendarsForm:fromCalendar_INPUT');
	setInputField('advSearchForm:toCalField', 'calendarsForm:toCalendar_INPUT');
}

function advancedSearch() {
	var hiddenSearchLink = document.getElementById("searchForm:hiddenAdvancedLink");
	var url = hiddenSearchLink.href;
	
	var all = document.getElementById("advSearchForm:advSearchAnd");
	if( all.value.length > 0 ) { 
		url = url + "&all=" + encodeURIComponent(all.value);
	}
	
	var exact = document.getElementById("advSearchForm:advSearchExact");
	if( exact.value.length > 0 ) { 
		url = url + "&exact=" + encodeURIComponent(exact.value);
	}
	
	var or = document.getElementById("advSearchForm:advSearchOr");
	if( or.value.length > 0 ) { 
		url = url + "&or=" + encodeURIComponent(or.value);
	}
	
	var not = document.getElementById("advSearchForm:advSearchNot");
	if( not.value.length > 0 ) { 
		url = url + "&none=" + encodeURIComponent(not.value);
	}
	
	var id = document.getElementById("advSearchForm:advSearchId");
	if( id.value.length > 0 ) { 
		url = url + "&id=" + encodeURIComponent(id.value);
	}
	
	var name = document.getElementById("advSearchForm:advSearchName");
	if( name.value.length > 0 ) { 
		url = url + "&name=" + encodeURIComponent(name.value);
	}
	
	var version = document.getElementById("advSearchForm:advSearchVersion");
	if( version.value.length > 0 ) { 
		url = url + "&ver=" + encodeURIComponent(version.value);
	}
	
	var shortDescription = document.getElementById("advSearchForm:advSearchShortDescription");
	if( shortDescription.value.length > 0 ) { 
		url = url + "&shortDesc=" + encodeURIComponent(shortDescription.value);
	}
	
	var description = document.getElementById("advSearchForm:advSearchDescription");
	if( description.value.length > 0 ) { 
		url = url + "&desc=" + encodeURIComponent(description.value);
	}
	
	var owner = document.getElementById("advSearchForm:advSearchOwner");
	if( owner.value.length > 0 ) { 
		url = url + "&owner=" + encodeURIComponent(owner.value);
	}
	
	var mod = document.getElementById("advSearchForm:advSearchLastModifier");
	if( mod.value.length > 0 ) { 
		url = url + "&mod=" + encodeURIComponent(mod.value);
	}
	
	var attrName = document.getElementById("advSearchForm:advSearchAttributeName");
	if( attrName.value.length > 0 ) { 
		url = url + "&attrName=" + encodeURIComponent(attrName.value);
	}
	
	var attrValue = document.getElementById("advSearchForm:advSearchAttributeValue");
	if( attrValue.value.length > 0 ) { 
		url = url + "&attrValue=" + encodeURIComponent(attrValue.value);
	}
	
	var artifact = document.getElementById("advSearchForm:advSearchArtifacts");
	if( artifact.checked ) { 
		url = url + "&sart=true";
	}
	
	var shadowAsset = document.getElementById("advSearchForm:advSearchShadow");
	if( shadowAsset.checked ) { 
		url = url + "&sshdw=true";
	}
	
	var forum = document.getElementById("advSearchForm:advSearchForums");
	if( forum.checked ) { 
		url = url + "&forum=true";
	}
	
	try {
		var fromCal = document.getElementById("advSearchForm:fromCalField");
		if( fromCal.value.length > 0 ) { 
			url = url + "&from=" + encodeURIComponent(fromCal.value);
		}
		
		var toCal = document.getElementById("advSearchForm:toCalField");
		if( toCal.value.length > 0 ) { 
			url = url + "&to=" + encodeURIComponent(toCal.value);
		}
	} catch(e) {}
	
	try {
		var fromCalSubmitted = document.getElementById("advSearchForm:fromCalFieldSubmitted");
		if( fromCalSubmitted.value.length > 0 ) { 
			url = url + "&submittedFrom=" + encodeURIComponent(fromCalSubmitted.value);
		}
		
		var toCalSubmitted = document.getElementById("advSearchForm:toCalFieldSubmitted");
		if( toCalSubmitted.value.length > 0 ) { 
			url = url + "&submittedTo=" + encodeURIComponent(toCalSubmitted.value);
		}
	} catch(e) {}

	window.location.href = url;
	return false;
}

function basicSearch(maintainSortSetting, groupVersions) {
	var text = document.getElementById("searchForm:searchText");
	var hiddenSearchLink = document.getElementById("searchForm:hiddenBasicLink");
	var searchArtifacts = document.getElementById("searchForm:searchArtifacts");
	var shadowAssets = document.getElementById("searchForm:searchShadowAssets");
	var searchForums = document.getElementById("searchForm:searchForums");
	var url = new StringBuffer();
	url.append(hiddenSearchLink.href);
	url.append("&txt=");
	url.append(encodeURIComponent(text.value));
	
	if( searchArtifacts.checked ) {
		url.append("&sart=true");
	}
	
	if( shadowAssets.checked ) {
		url.append("&sshdw=true");
	}		
		
	if( searchForums.checked ) {
		url.append("&forum=true");
	}
	
	if( maintainSortSetting ) {
		var sort = document.getElementById("resultsForm:sortSetting").value;
		if(sort != null && sort.length > 0) {
			url.append("&s=");
			url.append(sort);
		}
	}
	
	if(groupVersions != null && groupVersions.length > 0) {
		url.append("&groupVersions=");
		url.append(groupVersions);
	}
		
	window.location.href = url.toString();
	
	return false;
}

var updatedSearchResultCountChecks = 1;
function getUpdatedSearchResultCount(synchronizedSearch) {
	var renderResults = document.getElementById("resultsForm:renderResults");
	var resultCount = document.getElementById("resultsForm:resultCount").value;
	if(resultCount && renderResults && "true" == renderResults.value) {
		dojo.xhrGet({
			url: getAbsoluteUrl("internal/service/AssetSearchResultCountService.getAssetSearchResultCount"),
			handleAs: "text",
			headers: {"Accept": "application/json"},
			content: {text: document.getElementById("resultsForm:searchNodeField").value, synchronizedSearch: synchronizedSearch},
			timeout: 30000,
			
			// The LOAD function will be called on a successful response.
			load: function(response, ioArgs) {
				if(response > resultCount) {
					var difference = response - resultCount;
					document.getElementById("synchronizedSearchMessageText").innerHTML = difference 
						+ " more results since you started searching. <a href=\"javascript:;\" onclick=\"return basicSearch();\">Refresh results</a>.";
					var message = document.getElementById("synchronizedSearchMessage");
					if(message.style.display == "none") {
						dojo.animateProperty({
							node: message,
							properties: {
								height: 23
							},
							easing: dojo.fx.easing.quadOut,
							duration: 1000,
							beforeBegin: function(node) {
								dojo.style(node, 'display', '');
							}
						}).play();
					}
				} else {
					document.getElementById("synchronizedSearchMessage").style.display = "none";
				}
				updatedSearchResultCountChecks++;
				if(updatedSearchResultCountChecks < 20) {
					setTimeout("getUpdatedSearchResultCount(false)", 20000);
				}
			},
			
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("Error checking for updated search results.  HTTP status code: ", ioArgs.xhr.status);
			}
		});
	}
}

function showExpand(showLink, guid, version, dbid){
	var linkId = showLink.id;
	showLink.style.display = "none";
	
	var minusId = linkId.replace('artifactMatchLink','artifactMatchMinusLink');
	var minusLink = document.getElementById(minusId);
	minusLink.style.display = "inline";

	var assetRow = showLink.parentNode.parentNode.parentNode;
	assetRow.style.background = "#FFF4E2";

	var assetTable = assetRow.parentNode;
	var currentRow = assetTable.rows[assetRow.rowIndex-1];
	
	var toogleShow = currentRow.style.display!="none"
	
	if(currentRow.style.display!="none"){
		var artifactRow = assetTable.insertRow(assetRow.rowIndex);
		artifactRow.insertCell(0);
		var artifactCell = artifactRow.insertCell(1);
		artifactCell.colSpan = assetRow.cells.length-1;
		createPackageView(guid, version, artifactCell); 
		currentRowIndex = artifactRow.rowIndex;
		
		
	}
	else{
		assetTable.rows[assetRow.rowIndex].style.display="";
	}
}



function loadVersionList(guid, currentVersion, versionList, dbid, node){ 
	versionList = versionList.substring(1, versionList.length-1);
	var versions = versionList.split(','); 

	if(versions.length>1){	
		var pMenuBar = new dijit.Toolbar({id: "VersionToolbar"+dbid, "class": "VersionToolbar"});
	
		var menu = new jazz.ui.Menu({
			id: "VersionMenu"+dbid,
	        style: "display: none;"
	    });
	
		for (var i=0; i<versions.length; i++) {
			var version = versions[i].trim();
		    var menuItem = new dijit.MenuItem({
		        label: version
		    });
		    dojo.connect(menuItem.domNode, "onclick", dojo.hitch({id: version}, function() {changeVersion(guid, this.id, node);}));
		    
		    menu.addChild(menuItem);
		}   
	    var insertButton = new dijit.form.DropDownButton({
	        label: versions[0].trim(),
	        dropDown: menu,
	        showLabel: true
	    });
	     
	    pMenuBar.addChild(insertButton);
	    dojo.place(pMenuBar.domNode, node);
	    insertButton.setLabel(currentVersion);
	}
	else{
		node.innerHTML = versions[0].trim();
	}
	
}

function createPackageView(guid, version, parentContainer) { 	
	var innerHtml = new StringBuffer();  
	innerHtml.append('<div id="packageView'+guid+'" style="width:100%; padding:0px; margin:0 auto;"></div>');  
	parentContainer.innerHTML = innerHtml.toString(); 
	
	 
	var packageView = new ram.packageview.PackageView({
		guid: guid,
		version: version,
	});
	
	if(dojo.isIE > 9){
		packageView.domNode.style.setProperty("display", "inline");
	}
	dojo.place(packageView.domNode, dojo.byId("packageView"+guid));		
}   

function getStateIconUrl(stateResource) {
	var iconUrl = "";
	dojo.xhrGet({
		url: getAbsoluteUrl(stateResource),
		handleAs: "json",
		headers: {"Accept": "application/json"},

		sync: true,
		
		load: function(response, ioArgs) {
			if(response != null) {
				console.log(response);
				state = response.name;
				iconUrl = response.iconUrl;
				

			}
		},
		
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});	
	 
	return iconUrl;
}


function changeVersion(guid, vers, node){	 
	var rowNode = node.parentNode.parentNode;
	var tbodyNode = rowNode.parentNode;
	var rowIndex = rowNode.rowIndex-1;
	var rows = tbodyNode.rows; 
	var replaceRowIndex = -1; 
	for (var j = 0; j< rows.length; ++j) {
		var rowGuid = dojo.byId("resultsForm:searchResults:"+j+":guid"); 
		var rowVersion = dojo.byId("resultsForm:searchResults:"+j+":curversion"); 
		if (rowGuid == null || rowVersion == null) continue;
		if (rowGuid.value == guid && rowVersion.value == vers) { 
			var replaceRowNode = rowVersion.parentNode.parentNode;
			replaceRowIndex = replaceRowNode.rowIndex-1;
			if (replaceRowIndex == rowIndex) return;
			var versionChildren = rowVersion.parentNode.children; 
			if (versionChildren != null) {
				for (var x=0; x< versionChildren.length;++x){
					if (versionChildren[x].id == "addVersionDiv") {
						var versionWidgets = dijit.findWidgets(versionChildren[x]);
						if (versionWidgets == null || versionWidgets.length ==0) {
							versionChildren[x].innerHTML = "";
							var rowVersionsNode = dojo.byId("resultsForm:searchResults:"+rowIndex+":versions"); 
							var replaceVersionsNode = dojo.byId("resultsForm:searchResults:"+j+":versions"); 
							var dbidNode  = dojo.byId("resultsForm:searchResults:"+j+":dbid"); 
							replaceVersionsNode.value = rowVersionsNode.value;
							loadVersionList(guid, vers, replaceVersionsNode.value, dbidNode.value, versionChildren[x]); 
						
							
							break;
						}
					}
				}
			} 
			var rowMinusNode = rowNode.cells[0].children[0].lastChild; 
			var rowPlusNode = rowNode.cells[0].children[0].firstChild; 
			var replacerowMinusNode = dojo.byId("resultsForm:searchResults:"+j+":artifactMatchMinusLink"); 
			var replacerowPlusNode = dojo.byId("resultsForm:searchResults:"+j+":artifactMatchLink");  
			replacerowMinusNode.style.display = rowMinusNode.style.display;
			replacerowPlusNode.style.display = rowPlusNode.style.display;
			replaceRowNode.style.background = rowNode.style.background;
			break;
		}
		 
	}
	if (replaceRowIndex != -1) { 
		
		if(rowIndex == replaceRowIndex+1) {
			tbodyNode.insertBefore(rows[rowIndex], rows[replaceRowIndex]);
		} else if(replaceRowIndex == rowIndex+1) {
			tbodyNode.insertBefore(rows[replaceRowIndex], rows[rowIndex]);
		} else {
			var tmpNode = tbodyNode.replaceChild(rows[rowIndex], rows[replaceRowIndex]);
			if(typeof(rows[rowIndex]) != "undefined") {
				tbodyNode.insertBefore(tmpNode, rows[rowIndex]);
			}  
		} 
		rows[rowIndex].className = "evenRow";
		rows[replaceRowIndex].className = "hideRow";
		
	}
	var pkgViewNode = dojo.byId("packageView"+guid);
	if (pkgViewNode != null) {
		var widgets = dijit.findWidgets(pkgViewNode);
		if (widgets != null && widgets.length >0) {
			var packageViewWidget = widgets[0];
			if(packageViewWidget==null){
				return;
			}
			
			packageViewWidget.destroyRecursive();
			
			packageViewWidget = new ram.packageview.PackageView({
				guid: guid,
				version: vers
			});	
			dojo.place(packageViewWidget.domNode, dojo.byId("packageView"+guid));
		}
	} 
} 

function shrinkArtifacts(hideLink) {
	var linkId = hideLink.id;
	hideLink.style.display = "none";

	var plusId = linkId.replace('artifactMatchMinusLink','artifactMatchLink');
	var plusLink = document.getElementById(plusId);
	plusLink.style.display = "inline";
	
	var assetRow = hideLink.parentNode.parentNode.parentNode;
	assetRow.style.background = "";
	
	var assetTable = assetRow.parentNode;

	var currentRow = assetTable.rows[assetRow.rowIndex];
		currentRow.style.display = "none";
}

function showArtifacts(showLink) {
	var linkId = showLink.id;
	showLink.style.display = "none";
	
	var minusId = linkId.replace('artifactMatchLink','artifactMatchMinusLink');
	var minusLink = document.getElementById(minusId);
	minusLink.style.display = "inline";

	var artifactId = linkId.replace('artifactMatchLink','artifactZoomPanel');
	var artifactPanel = document.getElementById(artifactId);
	var assetRow = minusLink.parentNode.parentNode.parentNode;
	
	var assetRow = minusLink.parentNode.parentNode.parentNode;
	var assetTable = assetRow.parentNode;
	var currentRowIndex;
	if( artifactPanel.style.display == "none" ) {
		// Insert row below the asset row containing the artifacts
		var artifactRow = assetTable.insertRow(assetRow.rowIndex);
		artifactRow.className = assetRow.className;
		artifactRow.insertCell(0);
		var artifactCell = artifactRow.insertCell(1);
		artifactCell.colSpan = assetRow.cells.length-1;
		artifactCell.appendChild(artifactPanel);
		artifactPanel.style.display = "block";
		currentRowIndex = artifactRow.rowIndex;
	} else {
		// Show the already created row
		artifactPanel.parentNode.parentNode.className = assetRow.className + " visible";
		currentRowIndex = assetRow.rowIndex + 1;
	}
	
	// show any grouped version assets
	while(currentRowIndex < assetTable.rows.length) {
		var currentRow = assetTable.rows[currentRowIndex];
		if(currentRow.className.indexOf("hideRow") > -1) {
			currentRow.style.display = "table-row";
			var currentCells = assetTable.rows[currentRowIndex].cells;
			for(var i=0; i<currentCells.length; i++) {
				var html = currentCells[i].innerHTML;
				if(html.indexOf("<div style=\"overflow: hidden;") == 0) {
					html = html.substr(0, 29) + " padding: 0px; " + html.substr(29);
					currentCells[i].innerHTML = html;
				}
			}
			var previousCells = assetTable.rows[currentRowIndex-1].cells;
			for(var i=0; i<previousCells.length; i++) {
				previousCells[i].style.borderStyle = "none";
			}
			currentRowIndex++;
		} else {
			break;
		}
	}
}

function hideArtifacts(hideLink) {
	var linkId = hideLink.id;
	hideLink.style.display = "none";

	var plusId = linkId.replace('artifactMatchMinusLink','artifactMatchLink');
	var plusLink = document.getElementById(plusId);
	plusLink.style.display = "inline";
	
	var artifactId = linkId.replace('artifactMatchMinusLink','artifactZoomPanel');
	var artifactPanel = document.getElementById(artifactId);
	artifactPanel.parentNode.parentNode.className = "hidden";
	
	// hide any grouped version assets
	var currentRowIndex = artifactPanel.parentNode.parentNode.rowIndex;
	var assetTable = artifactPanel.parentNode.parentNode.parentNode;
	while(currentRowIndex < assetTable.rows.length) {
		var currentRow = assetTable.rows[currentRowIndex];
		if(currentRow.className.indexOf("hideRow") > -1) {
			currentRow.style.display = "none";
			currentRowIndex++;
		} else {
			break;
		}
	}	
}


function showPanel(showLink, matchLink, minusLink, panel) {
	var linkId = showLink.id;
	showLink.style.display = "none";
	
	var minusId = linkId.replace(matchLink,minusLink);
	var minusLink = document.getElementById(minusId);
	minusLink.style.display = "inline";

	var artifactId = linkId.replace(matchLink,panel);
	//alert("artifact id = " + artifactId );
	var artifactPanel = document.getElementById(artifactId);
	//alert("artifact panel= " + artifactPanel );
	var assetRow = minusLink.parentNode.parentNode.parentNode;
	
	 
	
	if( artifactPanel.style.display == "none" ) {
		// Insert row below the asset row containing the artifacts
		var assetRow = minusLink.parentNode.parentNode.parentNode;
	 
		var artifactRow = assetRow.parentNode.insertRow(assetRow.rowIndex + 1);
		artifactRow.className = assetRow.className;
		artifactRow.insertCell(0);
		var artifactCell = artifactRow.insertCell(1);
		artifactCell.colSpan = assetRow.cells.length-1;
		artifactCell.appendChild(artifactPanel);
		artifactPanel.style.display = "block";
	} else {
		// Show the already created row
		artifactPanel.parentNode.parentNode.className = assetRow.className + " visible";
	}
}

function hidePanel(hideLink, matchLink, minusLink, panel) {
	var linkId = hideLink.id;
	hideLink.style.display = "none";

	var plusId = linkId.replace(minusLink,matchLink);
	var plusLink = document.getElementById(plusId);
	plusLink.style.display = "inline";
	
	var artifactId = linkId.replace(minusLink,panel);
	var artifactPanel = document.getElementById(artifactId);
	artifactPanel.parentNode.parentNode.className = "hidden";
}


function hideSearchEngineIfRequired(){
	var hide = false;
	if(window.external){
		if("AddSearchProvider" in window.external){
			if("IsSearchProviderInstalled" in window.external){
				var url = getOpenSearchURL();
				if(window.external.IsSearchProviderInstalled(url)>0){
					hide = true;
				}
			}
		}else{
			hide = true;
		}
	}else{
		hide = true;
	}
	if(hide){
		var searchEngineLink = document.getElementById('searchEngineLink');
		searchEngineLink.className = "hidden";
	}
}

function installSearchEngine(){
	if (window.external && "AddSearchProvider" in window.external){
		var url = getOpenSearchURL();
		window.external.AddSearchProvider(url);
	} else {
		alert("${bundle.error_search_engine_not_supported}");
	}
}


function toggleSearchScope(link, scope) {
	if (scope == 1) {
		var id = 'searchForm:searchShadowAssets';
	} else if (scope == 2) {
		var id = 'searchForm:searchArtifacts';
	} else if (scope == 3) {
		var id = 'searchForm:searchForums';
	}
	
	var selected = !document.getElementById(id).checked;
	document.getElementById(id).checked = selected;
	var className = link.parentNode.className;
	if (selected) {
		if (className.indexOf('checked')==-1) {
			className = className + ' checked';
		}
	} else {
		if (className.indexOf('checked')!=-1) {
			className = className.substr(0, className.indexOf(' checked'));
		}
	}
	
	link.parentNode.className = className;
}


function toggleScopeMenu() {
	var v = document.getElementById('scopeItems').style.visibility;
	var src = document.getElementById('searchForm:scopeImage').src;
	if (v == 'visible') {
		src = src.substr(0, src.indexOf("/search_")) + '/search_scope_enabled.gif';
		hideMenu();
	} else {
		src = src.substr(0, src.indexOf("/search_")) + '/search_scope_press.gif';
		showMenu();
	}
	document.getElementById('searchForm:scopeImage').src = src;
}
function showMenu() {
	document.getElementById('scopeItems').style.visibility = 'visible';
}


function hideMenu() {
	document.getElementById('scopeItems').style.visibility = 'hidden';
}


function enableScopeImage() {
	var src = document.getElementById('searchForm:scopeImage').src;
	src = src.substr(0, src.indexOf("/search_")) + '/search_scope_enabled.gif';
	document.getElementById('searchForm:scopeImage').src = src;
	hideMenu();
}


function toggleSearchNodeField(linkObj, fieldId) {
	var linkId = linkObj.id;
	
	var field = document.getElementById(fieldId);
	var current = field.style.display;
	if (current == "none") {
		field.style.display = "inline";
		field.focus();
		field.select();
	} else {
		field.style.display = "none";
	}
}

function showAllCategories(facets) {
	for(var i=0; i<facets.childNodes.length; i++) {
		var item = facets.childNodes[i];
		if( item.nodeName == "LI" ) {
			if(/more$/.test(item.id)) {
				item.className = "hidden"
			} else {
				item.className = "visible";
			}
		} else {
			showAllCategories(item);
		}
	}
}

var facetFlyout;
var currentFacetName;

var flyoutSync = false;
var hideSubCat = false;
var flyoutSyncFunc;
var hideFlyoutLink;
function showFacetFlyout(facetName, forceShow, flyoutLink) {
	
	if(flyoutSync) {
		flyoutSyncFunc = function(){showFacetFlyout(facetName, forceShow, flyoutLink)};
	} else if(facetName == currentFacetName && !forceShow) {
		hideFacetFlyout();
	}else if(hideSubCat && flyoutLink.className == 'categoryMoreLink'){
		viewLessItems(facetName);
		hideSubCat = false;
		hideFlyoutLink = flyoutLink;
		hideFlyoutLink.childNodes[1].style.display = 'none';
		hideFlyoutLink.childNodes[0].style.display = '';
	} else if(document.getElementById(facetName + 'Flyout') == null) {
		viewAllItems(facetName);
		hideFlyoutLink = flyoutLink;
		flyoutLink.childNodes[0].style.display = 'none';
		flyoutLink.childNodes[1].style.display = '';
		hideSubCat = true;
	} else {
		
		if(flyoutLink != null) {
			if(hideFlyoutLink != null && hideFlyoutLink.className != 'categoryMoreLink') {
				hideFlyoutLink.childNodes[1].style.display = 'none';
				hideFlyoutLink.childNodes[0].style.display = '';
			}
			
		 	hideFlyoutLink = flyoutLink;
			flyoutLink.childNodes[0].style.display = 'none';
			flyoutLink.childNodes[1].style.display = '';
		}
		
		document.getElementById('flyoutFilterInput').value = "";
		if(facetFlyout != null) {
			facetFlyout.style.display = "none";
			if(currentFacetName == "Classification") {
				document.getElementById('classificationSearchFlyoutTitle').style.display = "none";
				document.getElementById('classificationSearchFlyout').style.display = "none";
			}
		}
		facetFlyout = document.getElementById(facetName + 'Flyout');
		
		if(facetFlyout.innerHTML == null || facetFlyout.innerHTML.length == 0) {
			var facetList = document.getElementById(facetName);
			if(facetList == null && facetName == "Classification") {
				facetList = document.getElementById("~" + facetName);
			}
			facetFlyout.appendChild(document.getElementById("facetTitle" + facetName).cloneNode(true));
			var facetCountsFlyoutDiv = document.createElement("div");
			facetCountsFlyoutDiv.id = "facetCountsFlyout" + facetName;
			facetFlyout.appendChild(facetCountsFlyoutDiv);
			facetCountsFlyoutDiv.appendChild(facetList.cloneNode(true));
			
			if("Classification" == facetName) {
				showAllCategories(facetFlyout);
			}
		}
		
		currentFacetName = facetName;
		if(currentFacetName != "Classification") {
			filterFacets('');
		}
		

		var filters = document.getElementById('filters');
		var filtersWidth = 600;
		
		if(currentFacetName == "Classification") {
			filtersWidth = 800
		}
		
		if(filters.offsetHeight < 375) {
			filters.style.height = "375px";
		}
		
		var moveArgs = {
			node: "filters",
			properties: {
				width: {
					start: filters.offsetWidth,
					end: filtersWidth,
					unit: "px"
				}
			},
			easing: dojo.fx.easing.quadOut,
			duration: 1000,
			onEnd: setFilterInputFocus
		};
		
		var filtersHeight = filters.style.height;
		var flyout = document.getElementById('flyout');
		var flyoutScrollDiv = document.getElementById('flyoutScrollDiv');
		if(!filtersHeight) {
			filtersHeight = filters.offsetHeight - 14;
			flyout.style.maxHeight = filtersHeight + "px";
			flyoutScrollDiv.style.maxHeight = filtersHeight + "px";
			document.getElementById("leftFilters").style.height = filtersHeight + "px";
		} else {
			flyout.style.maxHeight = filtersHeight;
			flyoutScrollDiv.style.maxHeight = filtersHeight;
			document.getElementById("leftFilters").style.height = filtersHeight;
		}
		flyout.style.left = "210px";
		flyout.style.width = filtersWidth - 210 +  "px";
		flyout.style.display = "block";
		
		dojo.animateProperty(moveArgs).play();
		
		if(facetFlyout != null) {
			facetFlyout.style.display = "block";
		}
		
		var flyoutScrollDiv = document.getElementById('flyoutScrollDiv');
		var flyoutScrollDivMaxHeight = flyoutScrollDiv.style.maxHeight.substring(0, (flyoutScrollDiv.style.maxHeight).length-2);
		flyoutScrollDiv.style.maxHeight = (flyoutScrollDivMaxHeight - (document.getElementById("flyoutHeader").offsetHeight)) + "px";
	}
}

function setFilterInputFocus() {
	dojo.byId('flyoutFilterInput').focus();
}


function hideFacetFlyout() {
	if(!flyoutSync) {
		flyoutSync = true;
		
		hideFlyoutLink.childNodes[1].style.display = 'none';
		hideFlyoutLink.childNodes[0].style.display = '';
		hideFlyoutlink = null;
		
		var moveArgs = {
			node: "filters",
			properties: {
				width: {
					start: dojo.byId('filters').offsetWidth,
					end: 190,
					unit: "px"
				}
			},
			easing: dojo.fx.easing.expoOut,
			duration: 2000,
			onEnd: finishHideFlyoutCallback
		};
		
		dojo.animateProperty(moveArgs).play();
	}
}

function finishHideFlyoutCallback() {
	document.getElementById('flyoutFilterInput').value = "";
	
	var flyout = document.getElementById('flyout');
	flyout.style.display = "none";
	if(facetFlyout != null) {
		facetFlyout.style.display = "none";
	}
	if(currentFacetName == "Classification") {
		document.getElementById('classificationSearchFlyoutTitle').style.display = "none";
		document.getElementById('classificationSearchFlyout').style.display = "none";
	}
	currentFacetName = null;
	document.getElementById('searchForm:searchText').focus();
	flyoutSync = false;
	if(flyoutSyncFunc) {
		flyoutSyncFunc();
		flyoutSyncFunc = null;
	}
}

function filterFacets(searchText, facets) {
	if(facets == null) {
		facets = document.getElementById('facetCountsFlyout' + currentFacetName);
	}
	if(facets != null) {
		if("facetCountsFlyoutClassification" == facets.id) {
			searchCategories(searchText);
		} else {
			searchText = searchText.toLowerCase();
			for(var i=0; i<facets.childNodes.length; i++) {
				var item = facets.childNodes[i];
				if( item.nodeName == "LI" ) {
					if(/more$/.test(item.id)) {
						item.className = "hidden"
					} else {
						var itemTextIE = item.children[0].children[0].children[0].children[0].children[0].children[0].innerText;
						var itemText = item.children[0].children[0].children[0].children[0].children[0].children[0].textContent;
						if(
								(navigator.appName.indexOf("Microsoft") >= 0 && (itemTextIE.toLowerCase().indexOf(searchText) == 0 || itemTextIE.toLowerCase().indexOf(' ' + searchText) >= 0))
							    || (navigator.appName.indexOf("Microsoft") == -1 && (itemText.toLowerCase().indexOf(searchText) == 0 || itemText.toLowerCase().indexOf(' ' + searchText) >= 0))) {
							item.className = "visible";
						} else {
							item.className = "hidden"
						}
					}
				} else {
					filterFacets(searchText, item);
				}
			}
		}
	}
}

var lastSearchCategoriesUpdateDate = new Date();
function searchCategories(searchText) {
	var time = new Date();
	if(searchText == null || searchText.length == 0) {
		lastSearchCategoriesUpdateDate = time
		showFacetFlyout("Classification", true);
		document.getElementById("categorySearchBusyIcon").style.display = "none";
	} else {
		document.getElementById("categorySearchBusyIcon").style.display = "inline";
		var pataData = document.getElementById("categoryPathData").value;
		dojo.xhrPost({
			url: getAbsoluteUrl("internal/service/CategorySearchService.search"),
			handleAs: "json",
			sync: false,
			content: {term: searchText, paths: pataData},
			
			load: function(response, ioArgs) {
				if(response != null && time > lastSearchCategoriesUpdateDate) {
					lastSearchCategoriesUpdateDate = time;
					var classificationSortValue = document.getElementById("classificationSearchSort").value;
					var classificationSearchArtifactValue = document.getElementById("classificationSearchArtifacts").value;
					var classificationSearchShadowAssetsValue = document.getElementById("classificationSearchShadowAssets").value;
					var classificationSearchForumsValue = document.getElementById("classificationSearchForums").value;
					var searchNodeValue = document.getElementById("classificationSearchFullNode").value;
					var searchNodeValueNoClassification = searchNodeValue.indexOf("Classification") == -1;
					var searchUrl = getAbsoluteUrl("search/index.faces");
					var html = new StringBuffer();
					html.append("<ul>");
					for(var key in response) {
						var facetSet = response[key];
						html.append("<li class=\"categorySearchPath\">");
						html.append(key);
						html.append("</li>");
						html.append("<ul>");
						for(var i=0; i<facetSet.length; i++) {
							var facet = facetSet[i];
							html.append("<li>");
							html.append("<a href=\"");
							html.append(searchUrl);
							html.append("?a=");
							html.append(encodeURIComponent(facet.facetName));
							html.append(",");
							html.append(encodeURIComponent(facet.itemName));
							html.append("&n=");
							var node = new StringBuffer();
							var encodedSchema = encodeURIComponent(facet.schema);
							if(searchNodeValue == null || searchNodeValue.length == 0) {
								node.append("1Classification," + encodedSchema);
							} else if(searchNodeValue.indexOf(encodedSchema) == -1) {
								node.append(searchNodeValue);
								if(searchNodeValueNoClassification) {
									node.append("$Classification,");
									node.append(encodedSchema);
								} else {
									node.append("$~Classification,")
									node.append(encodedSchema);
								}
							}
							html.append(node.toString());
							html.append("&s=");
							html.append(classificationSortValue);
							html.append("&sart=");
							html.append(classificationSearchArtifactValue);
							html.append("&sshdw=");
							html.append(classificationSearchShadowAssetsValue);
							html.append("&forum=");
							html.append(classificationSearchForumsValue);
							html.append("\">");
							html.append(facet.displayName);
							html.append("</a></li>");
						}
						html.append("</ul>");
					}
					html.append("</ul>");
					document.getElementById("ClassificationFlyout").style.display = "none";
					var classificationSearchFlyout = document.getElementById("classificationSearchFlyout");
					classificationSearchFlyout.innerHTML = html.toString();
					document.getElementById("classificationSearchFlyoutTitle").style.display = "block";
					classificationSearchFlyout.style.display = "block";
				}
				document.getElementById("categorySearchBusyIcon").style.display = "none";
			},
			
			error: function(response, ioArgs) {
				document.getElementById("categorySearchBusyIcon").style.display = "none";
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	}
}

var currentAllAnyNoneOptionsElement;
var currentOptionsElement;
function showAllAnyNoneOptions(optionsElement) {
	optionsElement.style.backgroundColor='#D8E7EB';
	currentOptionsElement = optionsElement;
	currentAllAnyNoneOptionsElement = optionsElement.children[1].children[0];
	currentAllAnyNoneOptionsElement.style.display = '';
}

function hideCurrentAllAnyNoneOptions() {
	if(currentAllAnyNoneOptionsElement != null) {
		currentAllAnyNoneOptionsElement.style.display = 'none';
		currentAllAnyNoneOptionsElement = null;
	}
	if(currentOptionsElement != null) {
		currentOptionsElement.style.backgroundColor = '';
		currentOptionsElement = null;
	}
}

var currentRemoveAllAnyNoneOptionsNode;
function showRemoveAllAnyNoneOptions(link) {
	currentRemoveAllAnyNoneOptionsNode = link;
	currentRemoveAllAnyNoneOptionsNode.style.backgroundColor = '#FFF4E2';
	currentRemoveAllAnyNoneOptionsNode.children[2].children[0].style.display = '';
}

function hideCurrentRemoveAllAnyNoneOptions() {
	if(currentRemoveAllAnyNoneOptionsNode != null) {
		currentRemoveAllAnyNoneOptionsNode.children[2].children[0].style.display = 'none';
		currentRemoveAllAnyNoneOptionsNode.style.backgroundColor = '#FFFFFF';
		currentRemoveAllAnyNoneOptionsNode = null;
	}
}