<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/myAssets/Summary.java" --%><%-- /jsf:pagecode --%>
<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2006. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  ----------------------------------------------------------------------------%>
<%--
 -  $$RCSfile: summary.jsp,v $$
 -  $$Revision: 1.92 $$  $$Date: 2007/08/22 21:38:00 $$
 --%> 
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>

<html lang="${pageContext.response.locale}">
<head>
	<%@include file="/theme/metaHeader.jspf"%>
	<%@include file="/theme/cssHideRightColumn.jspf"%>
	<link rel="csh" href="${applicationScope.cshPath}">
	<title>${bundle.myAssetManagerTitle}</title>
	<%-- Dojo layer imports  --%> 
	${pc_GeneralDetails.JSLayers['ram/layers/OpenSocial']}
	
	<script type="text/javascript">
		dojo.require('ram.opensocial.GadgetViewlet');
		function updateToDoCompleteDialog(thisObj) {			
			// update the dialog's content with the current obj's info		
			var hidden = document.getElementById("reqForm:todoCompletedId");
			hidden.value = thisObj.id;																
		}
		
		function updateToDoRemove(thisObj) {			
			// update the remove id content with the current obj's info		
			var hidden = document.getElementById("form1:todoRemoveId");
			hidden.value = thisObj.id;																
		}		
		
		function updateToDoDelegateDialog(thisObj) {
			// Get the title and message for the dialog
			var msgChild = thisObj.lastChild;
			var dialogMessage = msgChild.value;
			// Apply message
			var content = document.getElementById("todoDelegatePanelJSPContent");
			content.innerHTML = dialogMessage;
			// update the dialog's content with the current obj's info		
			var hidden = document.getElementById("todoDelegateForm:todoDelegateId");
			hidden.value = thisObj.id;																
		}
		
		function updateTodoGrantUserAccessDialog(thisObj) {
			// Get the title and message for the dialog
			var msgChild = thisObj.lastChild;
			var dialogMessage = msgChild.value;
			// Apply message
			var content = document.getElementById("todoGrantUserAccessPanelJSPContent");
			content.innerHTML = dialogMessage;
			// update the dialog's content with the current obj's info		
			var hidden = document.getElementById("todoGrantUserAccessForm:todoGrantUserAccessId");
			hidden.value = thisObj.id;																
		}
		
		dojo.addOnLoad(function() {
			dojo.xhrGet({
				url: getAbsoluteUrl('internal/service/GadgetService.getGadgets'),
				handleAs: 'json',
				load: function(gadgets) {
					dojo.forEach(gadgets, function(gadget) {
						var viewlet = new ram.opensocial.GadgetViewlet({url: gadget.url, canEdit: true, index: gadget.index});
						dojo.style(viewlet.domNode, 'margin', '10px 8px 10px 4px');
						dojo.place(viewlet.domNode, 'column1-span');
					});
				}
			});
		});
</script>	
	
	
</head>
<f:view>
	<body class="ram">
	<hx:scriptCollector id="scriptCollector1">
		<%@ include file="/theme/header.jspf" %>
		
<!-- Dialogs -->		
		<ram:form id="reqForm">
			<hx:panelDialog type="modeless" id="reqDialog" styleClass="panelDialog" movable="true"
				title="#{bundle.dialogTitle_mam_complete_task}" align="center" valign="relative" relativeTo="requestAccessButton">
				<h:panelGroup id="requestAccessGroup">
					<hx:panelFormBox id="requestAccessBox" styleClass="dialogForm" labelPosition="over" helpPosition="under">
						<hx:formItem id="CommentAccessFormItem" label="#{bundle.label_comments}" errorText="#{bundle.error_comments_validation_1000">
							<h:inputTextarea id="reqComments" value="#{pc_Summary.comments}" rows="5" cols="50">
								<f:validateLength maximum="1000"></f:validateLength>
							</h:inputTextarea>
						</hx:formItem>
					</hx:panelFormBox>

					<h:panelGroup id="requestAccessActionGroup" styleClass="dialogActionGroup">
						<hx:commandExButton id="okButton" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" type="submit" value="#{bundle.button_ok}"
							action="#{pc_Summary.doCompleteTodo}">
							<hx:behaviorKeyPress id="requestAccessEnterBehavior" key="Enter" behaviorAction="click" target="reqDialog" targetAction="okButton" />
						</hx:commandExButton>
						<hx:commandExButton id="cancelButton" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" type="button" value="#{bundle.button_cancel}">
							<hx:behavior event="onclick" id="requestAcessCancelBehavior" behaviorAction="hide;stop" targetAction="reqDialog" />
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
			<h:inputHidden  id="todoCompletedId" value="#{pc_Summary.todoCompleted}"/>
		</ram:form>
		<ram:form id="todoDelegateForm">
			<hx:panelDialog type="modeless" id="todoDelegateDialog" styleClass="panelDialog" movable="true" style="width:400px"
				title="#{bundle.dialogTitle_delegate_task}" align="center" valign="relative" relativeTo="requestAccessButton">
				<h:panelGroup id="todoDelegatePanel" >
					<hx:jspPanel id="todoDelegatePanelJSP">
						<p id="todoDelegatePanelJSPContent" class="sectionInstructions"></p>
					</hx:jspPanel>

					<h:panelGroup id="todoDelegateActionPanel" styleClass="dialogActionGroup">
						<hx:commandExButton id="todoDelegateOKButton" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" type="submit" value="#{bundle.button_ok}"	action="#{pc_Summary.doDelegateTask}">
							<hx:behaviorKeyPress id="todoDelegateOKEnterBehavior" key="Enter" behaviorAction="click" target="todoDelegateDialog" targetAction="okButton" />
						</hx:commandExButton>
						<hx:commandExButton id="todoDelegateCancelButton" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" type="button" value="#{bundle.button_cancel}">
							<hx:behavior event="onclick" id="todoDelegateCancelBehavior" behaviorAction="hide;stop" targetAction="todoDelegateDialog" />
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
			<h:inputHidden  id="todoDelegateId" value="#{pc_Summary.todoCompleted}"/>
		</ram:form>
		<ram:form id="todoGrantUserAccessForm">
			<hx:panelDialog type="modeless" id="todoGrantUserAccessDialog" styleClass="panelDialog" movable="true" style="width:400px"
				title="#{bundle.dialog_title_grant_permission}" align="center" valign="relative" relativeTo="requestAccessButton">
				<h:panelGroup id="todoGrantUserAccessPanel" >
					<hx:jspPanel id="todoGrantUserAccessPanelJSP">
						<p id="todoGrantUserAccessPanelJSPContent" class="sectionInstructions"></p>
					</hx:jspPanel>
					<h:selectOneRadio id="todoGrantUserAccessButtonGroup" layout="pageDirection" value="#{pc_Summary.grantUserAccessLevel}">
						<f:selectItem id="todoGrantUserAccessRead" itemLabel="#{bundle.grantRead}" itemValue="read"/>
						<f:selectItem id="todoGrantUserAccessDownload" itemLabel="#{bundle.grantDownload}" itemValue="download"/>
					</h:selectOneRadio>
					<h:panelGroup id="todoGrantUserAccessActionPanel" styleClass="dialogActionGroup">
						<hx:commandExButton id="todoGrantUserAccessOKButton" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" type="submit" value="#{bundle.button_ok}"	action="#{pc_Summary.doGrantUserAccessTask}">
							<hx:behaviorKeyPress id="todoGrantUserAccessOKEnterBehavior" key="Enter" behaviorAction="click" target="todoGrantUserAccessDialog" targetAction="okButton" />
						</hx:commandExButton>
						<hx:commandExButton id="todoGrantUserAccessCancelButton" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" type="button" value="#{bundle.button_cancel}">
							<hx:behavior event="onclick" id="todoGrantUserAccessCancelBehavior" behaviorAction="hide;stop" targetAction="todoGrantUserAccessDialog" />
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
			<h:inputHidden  id="todoGrantUserAccessId" value="#{pc_Summary.todoCompleted}"/>
		</ram:form>

		<ram:form id="submitEditorBusyDialogForm">
			<hx:panelDialog type="modal" align="center" valign="middle" 
				id="submitEditorBusyDialog" styleClass="panelDialog" style="width: 600px;"
				title="#{bundle.submit_wiz_submit_header_wait_text}" initiallyShow="#{pc_Summary.submitEditorBusyDialogVisible}">
					<div id="submitEditorBusyErrorMessage" class="warningBlock" style="margin-left: 15px">
						<div class="body">
							<div class="message">
								<h:outputText id="submitEditorBusyText" value="#{bundle.SubmitAssetHandler_submitEditorBusy}" escape="false"></h:outputText>
							</div>
						</div>
					</div>
				<h:panelGroup id="submitEditorBusyDialogGroup" style="width: 600px;">
					<h:panelGroup id="submitEditorBusyGroup" styleClass="dialogActionGroup">
						<hx:commandExButton id="submitWizYes" styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif"
							type="submit"
							value="#{bundle.button_continue}" action="#{pc_Summary.doSubmitActionForce}">
						</hx:commandExButton>
						<hx:commandExButton id="submitWizNo" styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif"
							type="submit"
							action="#{pc_Summary.doCancelSubmitEditorBusyAction}"
							value="#{bundle.button_cancel}">
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
		</ram:form>
							
		<!-- Dialogs End -->
		
		<div class="dashboard-page">
		<div id="contentColumn">
		<div class="inside">
			<div class="dashboard-content">
				<div id="column1-span" class="three-col-span">
					<div class="dashboard-page-title">
						<h:graphicImage id="imageEx1" value="#{pc_Summary.userImageURL}" 
							alt="#{bundle.alt_picture_user}" width="50" height="50" style="float: left; margin-right: 5px;" />
						
						<div style="display:block; margin-left: 55px;">	
							<h1 id="titleGroup" style="display:block; margin-bottom: 3px;">
								<h:outputText id="pageTitle" value="#{pc_Summary.pageTitle}" />
								<ram:infopop id="pageHelp" styleClass="pageHelp" 
								image="/theme/images/icons/obj16/info_indicator.gif" contextId="amsm0001"/>
							</h1>
							<h:outputLink id="emailLink" value="mailto:#{loginUser.user.email}" style="margin-right: 15px" >
								<h:outputText id="email" value="#{loginUser.user.email}"/>
							</h:outputLink>
							<ram:externalProfile id="userDetailExternal" value="#{loginUser.user.uid}" />
							<h:outputText id="phone" value="#{loginUser.user.phone}" style="margin-right: 5px" />
							<hx:requestLink id="settingsEditLink" action="#{pc_Summary.getUserPreferencesActionString}">
								<h:outputText id="settingsEditText" value="#{bundle.link_edit}" />
							</hx:requestLink>
						</div>
					</div>
					
					<div style="clear:both; height:0px; overflow:hidden;"><!-- Comment for IE --></div>
				
					<ram:form id="form1" styleClass="form">	
					<ram:panelSectionEx id="reviewSection" rendered="#{not empty pc_Summary.assetsToReview}"
						styleClass="ram-section orange" initClosed="false">
						<f:facet name="opened">			
							<h:outputText id="reviewOpenedHeaderTxt" value="#{pc_Summary.assetsToReviewViewletTitle}" escape="false" />
						</f:facet>
						<hx:dataTableEx border="0"
							rowClasses="oddRow, evenRow" value="#{pc_Summary.assetsToReview}"
							var="assets" id="assetsToReviewTable" styleClass="displayTable" columnClasses="noClass,noClass,actionColumn"
							width="100%" rows="5" summary="#{bundle.section_assets_review}">
							<hx:columnEx id="columnEx1" width="30%">
								<ram:resourceRequestLink id="link1" action="#{pc_Summary.getAssetDetailsActionString}" 
									value="#{assets.name}" uri="#{assets.resourceURI}">
									<f:param name="guid" id="param1" value="#{assets.id}"></f:param>
									<f:param name="v" id="param2" value="#{assets.version}"></f:param>
									<f:param name="submission" id="param3" value="#{assets.submissionAsset}"></f:param>
								</ram:resourceRequestLink>
							</hx:columnEx>
							<hx:columnEx id="column1" width="10%">
								<h:outputText id="text8" styleClass="outputText"
									value="#{assets.version}"></h:outputText>
							</hx:columnEx>
							<hx:columnEx id="column2" width="15%">
								<h:graphicImage id="reviewAssetStateImage" styleClass="stateIcon" value="#{assets.stateIconURL}"></h:graphicImage>
								<hx:requestLink id="reviewStateLink" action="#{pc_Summary.getReviewActionString}" rendered="#{assets.legacyReview}">
									<h:outputText id="reviewStateText" value="#{assets.stateName}" />
									<f:param name="guid" id="reviewParam1" value="#{assets.id}"></f:param>
									<f:param name="v" id="reviewParam2" value="#{assets.version}"></f:param>
									<f:param name="submission" id="reviewParam3" value="#{assets.submissionAsset}"></f:param>
								</hx:requestLink>
								<hx:requestLink id="lifecycleStateLink" action="#{pc_Summary.getLifecycleActionString}" rendered="#{!assets.legacyReview}">
									<h:outputText id="lifecycleStateText" value="#{assets.stateName}" />
									<f:param name="guid" id="lifecycleParam1" value="#{assets.id}"></f:param>
									<f:param name="v" id="lifecycleParam2" value="#{assets.version}"></f:param>
									<f:param name="submission" id="lifecycleParam3" value="#{assets.submissionAsset}"></f:param>
								</hx:requestLink>
							</hx:columnEx>
							<hx:columnEx id="column3" width="21%">
								<hx:requestLink id="reviewCommunityLink" action="communityDetails" value="#{assets.group}">
									<f:param id="reviewCommunityLinkParam" value="#{assets.communityId}" name="gid" />
								</hx:requestLink>
							</hx:columnEx>
							<hx:columnEx id="column4" width="12%">
								<h:outputText id="textReviewModifiedDate" styleClass="outputText" value="#{assets.lastModified}">
									<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Summary.timezone}" locale="#{pc_Summary.locale}" />
								</h:outputText>
							</hx:columnEx>
							<hx:columnEx id="column5" width="12%">
								<ram:resourceRequestLink id="link52" action="#{pc_Summary.getUserDetailActionString}"  rendered="#{assets.owners[0] != null}"
									value="#{assets.owners[0].name}" uri="#{assets.owners[0].resourceURI}">
									<f:param id="userDetailParamUID52" name="uid" value="#{assets.owners[0].id}"></f:param>
								</ram:resourceRequestLink>										
							</hx:columnEx>
						</hx:dataTableEx>
						
						<hx:panelBox id="assetsToReviewPagerGroup" styleClass="footerPanelBox" width="100%">
							<h:outputText id="rewviewViewAllLink" value="#{pc_Summary.assetsToReviewViewAllLink}" escape="false" rendered="#{pc_Summary.assetsToReviewSize > 5}" />
						</hx:panelBox>
					</ram:panelSectionEx>
					<ram:infopop for="reviewSection" styleClass="viewletInfopop" id="reviewHelp" contextId="amsm0060" placement="end" />
					
					<ram:panelSectionEx id="myTodosSection" rendered="#{not empty pc_Summary.myTodos}"
						styleClass="ram-section orange" initClosed="false">
						<f:facet name="opened">			
							<h:outputText id="myTodosHeaderTxt" value="#{pc_Summary.toDosViewletTitle}" escape="false" />
						</f:facet>
						<hx:dataTableEx border="0" rowClasses="oddRow, evenRow" 
							value="#{pc_Summary.myTodos}"  var="varTodo" 
							id="todoTable" 
							styleClass="displayTable" columnClasses="noClass,noClass,actionColumn" width="100%" rows="5" summary="#{bundle.section_tasks}">
							<hx:columnEx id="toDoCol1" width="25%" valign="top">
								<hx:dataIterator id="todoActionsItr" value="#{varTodo.actions}" var="varTodoAction" >
									<h:outputLink id="toDoCol1link"  style="display:block" value="#{varTodoAction.link}" rendered="#{varTodoAction.type==\"ACTION_TYPE_URL\"}">
										<h:outputText id="toDoCol1LinkText" value="#{varTodoAction.label}"></h:outputText>
									</h:outputLink>
									<hx:requestLink id="todoDelegateLink" style="display:block" onclick="updateToDoDelegateDialog(this);" title="#{bundle.alt_opens_dialog}" rendered="#{varTodoAction.type==\"ACTION_TYPE_DELEGATE_DIALOG\"}">
										<hx:behavior id="todoDelegateLinkBehavior" event="onclick" behaviorAction="show;stop" targetAction="todoDelegateDialog" />
										<h:outputText id="todoDelegateLinkText" value="#{varTodoAction.label}"/>
										<h:inputHidden id="todoDelegateDialogMsg" value="#{varTodoAction.dialogMessage}"></h:inputHidden>
									</hx:requestLink>
									<hx:requestLink id="todoGrantUserAccessLink" style="display:block" onclick="updateTodoGrantUserAccessDialog(this);" title="#{bundle.alt_opens_dialog}" rendered="#{varTodoAction.type==\"ACTION_TYPE_GRANT_USER_ACCESS_DIALOG\"}">
										<hx:behavior id="todoGrantUserAccessLinkBehavior" event="onclick" behaviorAction="show;stop" targetAction="todoGrantUserAccessDialog" />
										<h:outputText id="todoGrantUserAccessLinkText" value="#{varTodoAction.label}"/>
										<h:inputHidden id="todoGrantUserAccessDialogMsg" value="#{varTodoAction.dialogMessage}"></h:inputHidden>
									</hx:requestLink>
								</hx:dataIterator>
							</hx:columnEx>
							
							<hx:columnEx id="toDoCol2" width="10%" valign="top">
								<ram:resourceRequestLink id="originLink" action="#{pc_Summary.getUserDetailActionString}"
									value="#{varTodo.todo.requestUser.name}" uri="#{varTodo.requestURI}">
									<f:param id="originParamUID" name="uid" value="#{varTodo.todo.requestUser.uid}"></f:param>
								</ram:resourceRequestLink>					
							</hx:columnEx>
							
							<hx:columnEx id="toDoCol3" valign="top">
								
								<hx:panelSection id="todoTaskCollapseSection" initClosed="true" styleClass="taskCollapseSection">
									<f:facet name="closed">
										<h:panelGroup id="toDoCol3GroupClosed" styleClass="taskCollapseHeaderClosed">
											<hx:graphicImageEx id="myTaskCollapsed" 
												alt="#{bundle.alt_collapsed}"
												align="top" styleClass="collapsed" value="/theme/images/0x0.png" />
											<h:outputText id="taskClosedTitle" styleClass="ramTask" value="#{varTodo.todo.title}" />
										</h:panelGroup>
									</f:facet>
									<f:facet name="opened">
										<h:panelGroup id="toDoCol3GroupOpen" styleClass="taskCollapseHeaderOpened">
											<hx:graphicImageEx id="myTaskExpanded" 
												alt="#{bundle.alt_expanded}"
												styleClass="expanded" value="/theme/images/0x0.png" />
											<h:outputText id="taskOpenedTitle" styleClass="ramTask" value="#{varTodo.todo.title}" />
										</h:panelGroup>
									</f:facet>
									<h:panelGroup id="taskInformation">
										<h:outputText id="taskDescription" rendered="#{not varTodo.todo.completed}" escape="false" value="#{varTodo.todo.htmlEncodedFormattedDescription}" />
										<h:outputText id="taskDescriptionComplted" rendered="#{varTodo.todo.completed}" styleClass="completedTask" escape="false" value="#{varTodo.todo.htmlEncodedFormattedDescription}" />
										<h:outputText id="taskCompletedComments" rendered="#{varTodo.todo.completed}" escape="false" value="#{varTodo.todo.htmlEncodedFormattedCompletedComment}" />
									</h:panelGroup>
								</hx:panelSection>
							</hx:columnEx>
							
							<hx:columnEx id="toDoCol4" width="12%" valign="top">
								
								<h:outputText id="todoCol3time" styleClass="outputText" value="#{varTodo.todo.createdTime}" >
									<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Summary.timezone}" locale="#{pc_Summary.locale}" />
								</h:outputText>
							</hx:columnEx>				
							
							
							<hx:columnEx id="toDoCol5" width="85px" style="text-align: center" valign="top">									
								<hx:requestLink id="completeTodoButton" 
									onclick="updateToDoCompleteDialog(this);" title="#{bundle.alt_opens_dialog}"><hx:behavior id="toDoCol5Behavior" event="onclick" behaviorAction="show;stop" targetAction="reqDialog" />
									<h:outputText id="toDoCol5Completed" value="#{bundle.mam_task_completed}"/>
								</hx:requestLink>
							</hx:columnEx>
				
						</hx:dataTableEx>
						<hx:panelBox id="toDoShowAllBox" styleClass="footerPanelBox" width="100%" >
							<h:outputLink id="toDoShowAllLink" value="todo.faces">
								<h:outputText id="toDoShowAllText" value="#{bundle.mam_show_all}" />
							</h:outputLink>
						</hx:panelBox>
					</ram:panelSectionEx>
					<ram:infopop for="myTodosSections" styleClass="viewletInfopop" id="taskHelp" contextId="amsm0010" placement="end" />									
			
					<ram:panelSectionEx id="myRequestsSection" rendered="#{not empty pc_Summary.myRequests}"
						styleClass="ram-section" initClosed="false">
						<f:facet name="opened">
							<h:outputText id="myRequestHeaderTxt" value="#{bundle.section_pending_requests}" escape="false"></h:outputText>
						</f:facet>
						<h:inputHidden  id="todoRemoveId" value="#{pc_Summary.todoCompleted}"/>
						<hx:dataTableEx border="0" rowClasses="oddRow, evenRow" 
							value="#{pc_Summary.myRequests}"  var="varRequest" 
							id="requestTable" 
							styleClass="displayTable" width="100%" rows="5" summary="#{bundle.section_pending_requests}">
							<hx:columnEx id="requestCol1" width="55%">
							
								<hx:panelSection id="taskCollapsedSection" initClosed="true" styleClass="taskCollapseSection">
									<f:facet name="closed">
										<h:panelGroup id="requestSectionClosedGroup" styleClass="taskCollapseHeaderClosed">
											<hx:graphicImageEx id="myRequestsCollapsed" 
												alt="#{bundle.alt_collapsed}"
												align="top" styleClass="collapsed" value="/theme/images/0x0.png" />
											<h:outputText id="requestCommentText" styleClass="ramTask" value="#{varRequest.title}" />
										</h:panelGroup>
									</f:facet>
									<f:facet name="opened">
										<h:panelGroup id="requestSectionOpenGroup" styleClass="taskCollapseHeaderOpened">
											<hx:graphicImageEx id="myRequestExpanded" 
												alt="#{bundle.alt_expanded}"
												styleClass="expanded" value="/theme/images/0x0.png" />
											<h:outputText id="requestSectionFullText" styleClass="ramTask" value="#{varRequest.title}" />
										</h:panelGroup>
									</f:facet>
									<h:panelGroup id="requestInformation">
										<h:outputText id="requestDescription" rendered="#{not varRequest.completed}" escape="false" value="#{varRequest.htmlEncodedFormattedDescription}" />
										<h:outputText id="requestDescriptionComplted" rendered="#{varRequest.completed}" styleClass="completedTask" escape="false" value="#{varRequest.htmlEncodedFormattedDescription}" />
										<h:outputText id="requestCompletedComments" rendered="#{varRequest.completed}" escape="false" value="#{varRequest.htmlEncodedFormattedCompletedComment}" />
									</h:panelGroup>
								</hx:panelSection>
							</hx:columnEx>
							
							<hx:columnEx id="requestCol3" valign="top">
								
								<h:outputText id="requestCol3time" styleClass="outputText" value="#{varRequest.createdTime}">
									<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Summary.timezone}" locale="#{pc_Summary.locale}" />
								</h:outputText>
							</hx:columnEx>				
							
							<hx:columnEx id="requestCol4" valign="top">
							
								<h:outputText id="requestCol4time" styleClass="outputText" value="#{varRequest.completedDate}">
									<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Summary.timezone}" locale="#{pc_Summary.locale}" />
								</h:outputText>
							</hx:columnEx>	
							
							<hx:columnEx id="toDoCol5" width="85px" style="text-align: center" valign="top">									
								<h:commandLink id="removeToDoButton" action="#{pc_Summary.doRemoveTodo}" 
								 	onmousedown="updateToDoRemove(this);">
								 	<h:outputText id="toDoCol5Cancel" rendered="#{!varRequest.completed}" value="#{bundle.mam_task_cancel}"/>						
									<h:outputText id="toDoCol5Remove" rendered="#{varRequest.completed}" value="#{bundle.mam_task_remove}"/>
								</h:commandLink>
							</hx:columnEx>
										
							
						</hx:dataTableEx>
						<hx:panelBox id="requestPagerBox" styleClass="footerPanelBox" width="100%">
							<hx:pagerWeb id="requestPager" for="requestTable" rendered="#{pc_Summary.myRequests[5] != null}"
								style="display: block; text-align: right; width:100%"/>
						</hx:panelBox>
					</ram:panelSectionEx>
					<ram:infopop id="requestHelp" for="myRequestsSection" styleClass="viewletInfopop" contextId="amsm0050" placement="end" />
						
					<ram:panelSectionEx id="myFeedSection" image="/theme/images/icons/obj16/feed_vwr_pal16.gif"
						styleClass="ram-section myFeed-section" initClosed="false">
						<f:facet name="opened">
							<h:panelGroup id="myFeedSectionHeader" style="display: block;">
								<h:outputLink id="myFeedRSSFeed" value="#{pc_Summary.myEnrollmentsFeedUrl}">
									<hx:graphicImageEx id="rssImage" value="/theme/images/icons/obj16/RSS_feed_sm_obj.gif" alt="#{bundle.my_feed}" title="#{bundle.my_feed}" style="float: right; padding-top: 3px;"/>
								</h:outputLink>
								<h:outputText id="myFeedHeaderTxt"
									value="#{pc_Summary.myFeedViewletTitle}" escape="false" />					
							</h:panelGroup>
						</f:facet>
						<hx:dataTableEx border="0" cellpadding="2" cellspacing="2"
							id="myFeedTable"
							styleClass="displayTable" width="100%" rows="7"
							rowClasses="oddRow,evenRow"
							value="#{pc_Summary.myEnrolledAssetsActivity}"
							var="feedActivity">
			
							<hx:columnEx id="actDescription3">
								<h:panelGroup id="activityEventPanelGroup" style="display:block; word-wrap:break-word;">
									<!-- h:graphicImage id="imageEx1" value="#{feedActivity.userImageURL}" 
									alt="#{bundle.alt_picture_user}" width="30" height="30" style="float: left; margin-right: 5px;" /-->
									<h:graphicImage id="descTextImage" value="#{feedActivity.icon}" styleClass="eventIconForDashboard" 
										rendered="#{feedActivity.iconAvailable}" />
									<h:outputText id="actDescText3withIcon"
										value="#{feedActivity.sentenceDescription}" escape="false"
										styleClass="noIconEvent" rendered="#{feedActivity.iconAvailable}"/>
									<h:outputText id="actDescText3"
										value="#{feedActivity.sentenceDescription}" escape="false"
										styleClass="myFeedAssetActivityLabelBackgroundImageForDashboard #{feedActivity.eventStyle}" rendered="#{!feedActivity.iconAvailable}"/>
									<h:outputText id="eventTime"
										value="#{feedActivity.timestampString}" escape="false" 
										styleClass="eventTime"/>
								</h:panelGroup>
							</hx:columnEx>
						</hx:dataTableEx>
						
						<hx:panelBox id="myFeedPagerGroup" styleClass="footerPanelBox" width="100%" >
							<h:outputLink id="myFeedPagerAllLink" value="myfeed.faces" rendered="#{pc_Summary.numberOfMyEnrolledAssetsActivities > 0}">
								<h:outputText id="myFeedPagerAllLinkText" value="#{bundle.mam_show_all}"/>
							</h:outputLink>
						</hx:panelBox>
					</ram:panelSectionEx>
					<ram:infopop styleClass="viewletInfopop" for="myFeedSection" id="myFeedsHelp" contextId="amsm0015" placement="end" />			
			
					<ram:panelSectionEx id="reviewManageSection" rendered="#{not empty pc_Summary.assetsToManage}" styleClass="ram-section" initClosed="false">
						<f:facet name="opened">			
							<h:outputText id="reviewManageOpenedHeaderTxt" value="#{pc_Summary.assetsToManageViewletTitle}" escape="false" />
						</f:facet>
						<hx:dataTableEx border="0"
							rowClasses="oddRow, evenRow" value="#{pc_Summary.assetsToManage}"
							var="assets" id="assetsToManageTable" styleClass="displayTable" columnClasses="noClass,noClass,actionColumn"
							width="100%" rows="5" summary="#{bundle.section_assets_to_manage}">
							<hx:columnEx id="columnEx1" width="30%">
								<ram:resourceRequestLink id="link7" action="#{pc_Summary.getAssetDetailsActionString}" 
									value="#{assets.name}" uri="#{assets.resourceURI}">
									<f:param name="guid" id="manage1" value="#{assets.id}"></f:param>
									<f:param name="v" id="manage2" value="#{assets.version}"></f:param>
									<f:param name="submission" id="manage3" value="#{assets.submissionAsset}"></f:param>
								</ram:resourceRequestLink>
							</hx:columnEx>
							<hx:columnEx id="column1" width="10%">
								<h:outputText id="text8" styleClass="outputText"
									value="#{assets.version}"></h:outputText>
							</hx:columnEx>
							<hx:columnEx id="column2" width="15%">
								<h:graphicImage id="reviewManageAssetStateImage" styleClass="stateIcon" value="#{assets.stateIconURL}"></h:graphicImage>
								<hx:requestLink id="reviewManageStateLink" action="#{pc_Summary.getReviewActionString}" rendered="#{assets.legacyReview}">
									<h:outputText id="reviewManageStateText" value="#{assets.stateName}" />
									<f:param name="guid" id="reviewManageParam1" value="#{assets.id}"></f:param>
									<f:param name="v" id="reviewManageParam2" value="#{assets.version}"></f:param>
									<f:param name="submission" id="reviewManageParam3" value="#{assets.submissionAsset}"></f:param>
								</hx:requestLink>
								<hx:requestLink id="lifecycleManageStateLink" action="#{pc_Summary.getLifecycleActionString}" rendered="#{!assets.legacyReview}">
									<h:outputText id="lifecycleManageStateText" value="#{assets.stateName}" />
									<f:param name="guid" id="lifecycleManageParam1" value="#{assets.id}"></f:param>
									<f:param name="v" id="lifecycleManageParam2" value="#{assets.version}"></f:param>
									<f:param name="submission" id="lifecycleManageParam3" value="#{assets.submissionAsset}"></f:param>
								</hx:requestLink>
							</hx:columnEx>
							<hx:columnEx id="column3" width="21%">
								<hx:requestLink id="reviewManageCommunityLink" action="communityDetails" value="#{assets.group}">
									<f:param id="reviewManageCommunityLinkParam" value="#{assets.communityId}" name="gid" />
								</hx:requestLink>
							</hx:columnEx>
							<hx:columnEx id="column4" width="12%">
								<h:outputText id="textReviewManageModifiedDate" styleClass="outputText" value="#{assets.lastModified}">
									<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Summary.timezone}" locale="#{pc_Summary.locale}" />
								</h:outputText>
							</hx:columnEx>
							<hx:columnEx id="column5" width="12%">
								<ram:resourceRequestLink id="link2" action="#{pc_Summary.getUserDetailActionString}"  rendered="#{assets.owners[0] != null}"
									value="#{assets.owners[0].name}" uri="#{assets.owners[0].resourceURI}">
									<f:param id="userDetailParamUID" name="uid" value="#{assets.owners[0].id}"></f:param>
								</ram:resourceRequestLink>					
							</hx:columnEx>
						</hx:dataTableEx>
						
						<hx:panelBox id="assetsToManagePagerGroup" styleClass="footerPanelBox" width="100%">
							<h:outputText id="reviewManageViewAllLink" value="#{pc_Summary.assetsToManageViewAllLink}" escape="false" rendered="#{pc_Summary.assetsToManageSize > 5}" />
						</hx:panelBox>
					</ram:panelSectionEx>
					<ram:infopop for="reviewManageSection" styleClass="viewletInfopop" id="reviewManageHelp" contextId="amsm0065" placement="end" />
					</ram:form>
				</div>
				<div id="column3" class="three-col">
					<ram:form id="submitAssetButtonForm">
						<div style="width: 205px; margin-bottom: 10px;  margin-right: 10px; float: right;"> <!-- This div is for IE6 -->
						<h:commandLink id="submitAssetButton" action="#{pc_Summary.doSubmitAssetAction}" rendered="#{pc_Summary.submitter}"
							styleClass="action-Button" title="#{bundle.alt_submit_an_asset}">
							<hx:jspPanel id="submitButtonPanel">
							<div class="buttonWrapper largeButton">
								<div class="buttonLeft">
								<table>
									<tbody>
									<tr>
										<td valign="middle"><div class="image create-asset-command"></div></td>
										<td valign="middle">${bundle.button_submit_an_asset_html}</td>
									</tr>
									</tbody>
								</table>
								</div>
								<div class="buttonRight" style="right: 0px;"></div>
							</div>
							</hx:jspPanel>
						</h:commandLink>
						</div>
					</ram:form>
					
					<ram:panelSectionEx id="myAssetsSection" styleClass="ram-section" initClosed="false" image="/theme/images/icons/obj16/my_assets.gif" style="clear: both">
						<f:facet name="opened">			
							<h:outputText id="myAssetsOpenedHeaderTxt" value="#{pc_Summary.myAssetsViewletTitle}" escape="false" />
						</f:facet>
					
						<hx:dataTableEx border="0" 
							id="ownedAssetsTable" width="100%" styleClass="listTable fixed"
							headerClass="headerClass"  rows="10" columnClasses="noClass,noClass,actionColumn"
							value="#{pc_Summary.recentlyUpdatedAssets}" var="assets" summary="#{bundle.section_recently_updated}">
							<hx:columnEx style="white-space: nowrap;">
								<ram:resourceRequestLink id="link3" action="#{pc_Summary.getAssetDetailsActionString}" 
									value="#{assets.name} #{bundle.common_ltr_mark}[#{assets.version}]" uri="#{assets.resourceURI}">
									<f:param name="guid" id="ownedAssetId" value="#{assets.id}"></f:param>
									<f:param name="v" id="ownedAssetVersion" value="#{assets.version}"></f:param>
									<f:param name="submission" id="ownedAssetSubmission" value="#{assets.submissionAsset}"></f:param>
								</ram:resourceRequestLink>
							</hx:columnEx>			
						</hx:dataTableEx>
						
						<hx:panelBox id="myAssetsPagerGroup" styleClass="footerPanelBox" width="100%">
							<h:outputText id="myAssetsViewAllLink" value="#{pc_Summary.myAssetsViewAllLink}" escape="false"  />
						</hx:panelBox>
					</ram:panelSectionEx>
					<ram:infopop styleClass="viewletInfopop" for="myAssetsSection" id="myAssetsHelp" contextId="amsm0020" placement="end" />
				
					<ram:panelSectionEx id="tagsSection" styleClass="ram-section" initClosed="false" image="/theme/images/icons/obj16/my_tags.gif">
						<f:facet name="opened">			
							<h:outputText id="tagsOpenedHeaderTxt" value="#{bundle.navigation_mam_tags}" />
						</f:facet>
						<ram:tagCloud value="#{pc_Summary.tags}" id="myTagCloud" tagVar="tag" tagCountVar="tagCount" tagClass="tagCloud" maxTags="20">
							<hx:requestLink id="tagCloudTagLink" action="#{pc_Summary.getTaggedAssetsActionString}">
								<h:outputText id="tagCloudTagText" value="#{tag}" />
								<f:param id="tagCloudTagParam" name="t" value="#{tag}" />
							</hx:requestLink>
						</ram:tagCloud>
						<hx:panelBox id="tagsEditBox" rendered="#{not empty pc_Summary.tags.items}"
							styleClass="footerPanelBox" width="100%">
							<h:outputLink id="tagsEditLink" value="tags.faces">
								<h:outputText id="tagsEditText" value="#{bundle.mam_show_all}" />
							</h:outputLink>
						</hx:panelBox>
					</ram:panelSectionEx>
					<ram:infopop styleClass="viewletInfopop" 
						for="tagsSection" 
						id="tagsHelp" 
						contextId="amsm0080" 
						placement="end" />
						
					<ram:panelSectionEx id="downloadSection" styleClass="ram-section" initClosed="false" image="/theme/images/icons/obj16/downloaded_asset.gif">
						<f:facet name="opened">			
							<h:outputText id="downloadOpenedHeaderTxt" value="#{pc_Summary.downloadsViewletTitle}" escape="false"></h:outputText>
						</f:facet>
						<hx:dataTableEx border="0" id="downloadedAssetsTable" rows="10" width="100%"
							styleClass="listTable fixed" columnClasses="noClass,noClass,actionColumn"
							value="#{pc_Summary.recentlyDownloadedAssets}" var="download" summary="#{bundle.alt_table_recently_downloaded_assets}">
							<hx:columnEx id="dlName"  style="white-space: nowrap;">
								<ram:resourceRequestLink id="dlLink" action="#{pc_Summary.getAssetDetailsActionString}" 
									value="#{download.asset.name} #{bundle.common_ltr_mark}[#{download.asset.version}]" uri="#{download.asset.resourceURI}">
									<f:param name="guid" id="dlAssetId" value="#{download.asset.id}"></f:param>
									<f:param name="v" id="dlAssetVersion" value="#{download.asset.version}"></f:param>
									<f:param name="submission" id="dlAssetSubmission" value="#{download.asset.submissionAsset}"></f:param>
								</ram:resourceRequestLink>
							</hx:columnEx>														
						</hx:dataTableEx>
						<hx:panelBox id="dlShowAllBox" styleClass="footerPanelBox" width="100%" >
							<h:outputLink id="dlShowAllLink" value="downloaded.faces">
								<h:outputText id="dlShowAllText" value="#{bundle.mam_show_all}" />
							</h:outputLink>
						</hx:panelBox>
					</ram:panelSectionEx>
					<ram:infopop styleClass="viewletInfopop" for="downloadSection" id="recentlyDownloadedHelp" contextId="amsm0030" placement="end" />
					
					<ram:panelSectionEx id="subscriptionsSection" styleClass="ram-section" initClosed="false" image="/theme/images/icons/obj16/my_subscriptions.gif">
						<f:facet name="opened">			
							<h:outputText id="subscriptionsOpenedHeaderTxt" value="#{pc_Summary.subscriptionsViewletTitle}" escape="false" />
						</f:facet>
					
						<hx:dataTableEx styleClass="listTable fixed"  border="0"
							headerClass="headerClass"  rows="10"
							id="subscriptionTable" value="#{pc_Summary.subscriptions}" var="varsub" summary="#{bundle.section_email_subscriptions}">
							<hx:columnEx id="subNameColumn" style="white-space: nowrap;">
								<ram:resourceRequestLink id="subNameLink" action="subscriptionShow" 
									rendered="#{varsub.asset}" value="#{varsub.name}" uri="#{varsub.resourceURI}">
									<f:param id="subTypeParam" name="subt" value="#{varsub.param[0]}" />
									<f:param id="subGuidParam" name="guid" value="#{varsub.param[1]}" />
									<f:param id="subVParam" name="v" value="#{varsub.param[2]}" />
								</ram:resourceRequestLink>
								<hx:requestLink id="subNameLink2" action="#{pc_Summary.getSearchActionString}" rendered="#{varsub.search}" title="#{varsub.name}">
									<h:outputText id="subNameLink2Text" value="#{varsub.name}" />
									<f:param id="subNameParam2" name="#{varsub.paramName}" value="#{varsub.param[0]}" />
								</hx:requestLink>
								<hx:requestLink id="subNameLink3" action="subscriptionShow" rendered="#{varsub.forum}" title="#{varsub.name}">
									<h:outputText id="subNameLink3Text" value="#{varsub.name}"/>
									<f:param id="subTypeParam3" name="subt" value="#{varsub.param[0]}" />
									<f:param id="subGuidParam3" name="guid" value="#{varsub.param[1]}" />
									<f:param id="subVParam3" name="v" value="#{varsub.param[2]}" />
									<f:param id="subFIDParam3" name="fid" value="#{varsub.param[3]}" />
								</hx:requestLink>
								<hx:requestLink id="subNameLink4" action="subscriptionShow" rendered="#{varsub.topic}" title="#{varsub.name}">
									<h:outputText id="subNameLink4Text" value="#{varsub.name}"/>
									<f:param id="subTypeParam4" name="subt" value="#{varsub.param[0]}" />
									<f:param id="subGuidParam4" name="guid" value="#{varsub.param[1]}" />
									<f:param id="subVParam4" name="v" value="#{varsub.param[2]}" />							
									<f:param id="subTIDParam4" name="tid" value="#{varsub.param[3]}" />
								</hx:requestLink>
							</hx:columnEx>
						</hx:dataTableEx>
						<hx:panelBox id="subShowAllBox" 
							styleClass="footerPanelBox" width="100%" >
							<h:outputLink id="subEditLink" value="subscriptions.faces">
								<h:outputText id="subEditText" value="#{bundle.mam_show_all}" />
							</h:outputLink>
						</hx:panelBox>
						
					</ram:panelSectionEx>
					<ram:infopop styleClass="viewletInfopop" for="subscriptionsSection" id="subscriptionHelp" contextId="amsm0040" placement="end" />
				</div>
			</div>
		</div>
		</div>
		</div>

		
		<%@include file="../theme/footer.jspf"%>
	</hx:scriptCollector>
	</body>
</f:view>
</html>
